/// Represents a individual programming language. Can be used to provide
/// information about the language, such as multi line comments, single line
/// comments, string literal syntax, whether a given language allows nesting
/// comments.
#[derive(Deserialize, Serialize)]
#[derive(Clone, Copy, Debug, Eq, Hash, Ord, PartialEq, PartialOrd)]
#[non_exhaustive]
pub enum LanguageType {
        #[allow(missing_docs)]Abap,
    
        #[allow(missing_docs)]ActionScript,
    
        #[allow(missing_docs)]Ada,
    
        #[allow(missing_docs)]Agda,
    
        #[allow(missing_docs)]Alex,
    
        #[allow(missing_docs)]Arduino,
    
        #[allow(missing_docs)]Asn1,
    
        #[allow(missing_docs)]Asp,
    
        #[allow(missing_docs)]AspNet,
    
        #[allow(missing_docs)]Assembly,
    
        #[allow(missing_docs)]AssemblyGAS,
    
        #[allow(missing_docs)]AutoHotKey,
    
        #[allow(missing_docs)]Autoconf,
    
        #[allow(missing_docs)]Automake,
    
        #[allow(missing_docs)]Bash,
    
        #[allow(missing_docs)]Batch,
    
        #[allow(missing_docs)]BrightScript,
    
        #[allow(missing_docs)]C,
    
        #[allow(missing_docs)]CHeader,
    
        #[allow(missing_docs)]CMake,
    
        #[allow(missing_docs)]CSharp,
    
        #[allow(missing_docs)]CShell,
    
        #[allow(missing_docs)]Cabal,
    
        #[allow(missing_docs)]Cassius,
    
        #[allow(missing_docs)]Ceylon,
    
        #[allow(missing_docs)]Clojure,
    
        #[allow(missing_docs)]ClojureC,
    
        #[allow(missing_docs)]ClojureScript,
    
        #[allow(missing_docs)]Cobol,
    
        #[allow(missing_docs)]CoffeeScript,
    
        #[allow(missing_docs)]Cogent,
    
        #[allow(missing_docs)]ColdFusion,
    
        #[allow(missing_docs)]ColdFusionScript,
    
        #[allow(missing_docs)]Coq,
    
        #[allow(missing_docs)]Cpp,
    
        #[allow(missing_docs)]CppHeader,
    
        #[allow(missing_docs)]Crystal,
    
        #[allow(missing_docs)]Css,
    
        #[allow(missing_docs)]D,
    
        #[allow(missing_docs)]Dart,
    
        #[allow(missing_docs)]DeviceTree,
    
        #[allow(missing_docs)]Dhall,
    
        #[allow(missing_docs)]Dockerfile,
    
        #[allow(missing_docs)]DotNetResource,
    
        #[allow(missing_docs)]DreamMaker,
    
        #[allow(missing_docs)]Dust,
    
        #[allow(missing_docs)]Edn,
    
        #[allow(missing_docs)]Elisp,
    
        #[allow(missing_docs)]Elixir,
    
        #[allow(missing_docs)]Elm,
    
        #[allow(missing_docs)]Elvish,
    
        #[allow(missing_docs)]EmacsDevEnv,
    
        #[allow(missing_docs)]Emojicode,
    
        #[allow(missing_docs)]Erlang,
    
        #[allow(missing_docs)]FEN,
    
        #[allow(missing_docs)]FSharp,
    
        #[allow(missing_docs)]Fish,
    
        #[allow(missing_docs)]FlatBuffers,
    
        #[allow(missing_docs)]Forth,
    
        #[allow(missing_docs)]FortranLegacy,
    
        #[allow(missing_docs)]FortranModern,
    
        #[allow(missing_docs)]FreeMarker,
    
        #[allow(missing_docs)]Fstar,
    
        #[allow(missing_docs)]Futhark,
    
        #[allow(missing_docs)]GDB,
    
        #[allow(missing_docs)]GdScript,
    
        #[allow(missing_docs)]Gherkin,
    
        #[allow(missing_docs)]Glsl,
    
        #[allow(missing_docs)]Go,
    
        #[allow(missing_docs)]Gohtml,
    
        #[allow(missing_docs)]Graphql,
    
        #[allow(missing_docs)]Groovy,
    
        #[allow(missing_docs)]Hamlet,
    
        #[allow(missing_docs)]Handlebars,
    
        #[allow(missing_docs)]Happy,
    
        #[allow(missing_docs)]Haskell,
    
        #[allow(missing_docs)]Haxe,
    
        #[allow(missing_docs)]Hcl,
    
        #[allow(missing_docs)]Headache,
    
        #[allow(missing_docs)]Hex,
    
        #[allow(missing_docs)]Hlsl,
    
        #[allow(missing_docs)]HolyC,
    
        #[allow(missing_docs)]Html,
    
        #[allow(missing_docs)]Idris,
    
        #[allow(missing_docs)]Ini,
    
        #[allow(missing_docs)]IntelHex,
    
        #[allow(missing_docs)]Isabelle,
    
        #[allow(missing_docs)]Jai,
    
        #[allow(missing_docs)]Java,
    
        #[allow(missing_docs)]JavaScript,
    
        #[allow(missing_docs)]Json,
    
        #[allow(missing_docs)]Jsx,
    
        #[allow(missing_docs)]Julia,
    
        #[allow(missing_docs)]Julius,
    
        #[allow(missing_docs)]KakouneScript,
    
        #[allow(missing_docs)]Kotlin,
    
        #[allow(missing_docs)]LLVM,
    
        #[allow(missing_docs)]Lean,
    
        #[allow(missing_docs)]Less,
    
        #[allow(missing_docs)]LinkerScript,
    
        #[allow(missing_docs)]Liquid,
    
        #[allow(missing_docs)]Lisp,
    
        #[allow(missing_docs)]Logtalk,
    
        #[allow(missing_docs)]Lua,
    
        #[allow(missing_docs)]Lucius,
    
        #[allow(missing_docs)]Madlang,
    
        #[allow(missing_docs)]Makefile,
    
        #[allow(missing_docs)]Markdown,
    
        #[allow(missing_docs)]Meson,
    
        #[allow(missing_docs)]Mint,
    
        #[allow(missing_docs)]ModuleDef,
    
        #[allow(missing_docs)]MoonScript,
    
        #[allow(missing_docs)]MsBuild,
    
        #[allow(missing_docs)]Mustache,
    
        #[allow(missing_docs)]Nim,
    
        #[allow(missing_docs)]Nix,
    
        #[allow(missing_docs)]NotQuitePerl,
    
        #[allow(missing_docs)]OCaml,
    
        #[allow(missing_docs)]ObjectiveC,
    
        #[allow(missing_docs)]ObjectiveCpp,
    
        #[allow(missing_docs)]Odin,
    
        #[allow(missing_docs)]OpenType,
    
        #[allow(missing_docs)]Org,
    
        #[allow(missing_docs)]Oz,
    
        #[allow(missing_docs)]PSL,
    
        #[allow(missing_docs)]Pan,
    
        #[allow(missing_docs)]Pascal,
    
        #[allow(missing_docs)]Perl,
    
        #[allow(missing_docs)]Perl6,
    
        #[allow(missing_docs)]Pest,
    
        #[allow(missing_docs)]Php,
    
        #[allow(missing_docs)]Polly,
    
        #[allow(missing_docs)]Pony,
    
        #[allow(missing_docs)]PostCss,
    
        #[allow(missing_docs)]PowerShell,
    
        #[allow(missing_docs)]Processing,
    
        #[allow(missing_docs)]Prolog,
    
        #[allow(missing_docs)]Protobuf,
    
        #[allow(missing_docs)]PureScript,
    
        #[allow(missing_docs)]Python,
    
        #[allow(missing_docs)]Qcl,
    
        #[allow(missing_docs)]Qml,
    
        #[allow(missing_docs)]R,
    
        #[allow(missing_docs)]RON,
    
        #[allow(missing_docs)]RPMSpecfile,
    
        #[allow(missing_docs)]Racket,
    
        #[allow(missing_docs)]Rakefile,
    
        #[allow(missing_docs)]Razor,
    
        #[allow(missing_docs)]ReStructuredText,
    
        #[allow(missing_docs)]Renpy,
    
        #[allow(missing_docs)]Ruby,
    
        #[allow(missing_docs)]RubyHtml,
    
        #[allow(missing_docs)]Rust,
    
        #[allow(missing_docs)]SRecode,
    
        #[allow(missing_docs)]Sass,
    
        #[allow(missing_docs)]Scala,
    
        #[allow(missing_docs)]Scheme,
    
        #[allow(missing_docs)]Scons,
    
        #[allow(missing_docs)]Sh,
    
        #[allow(missing_docs)]Sml,
    
        #[allow(missing_docs)]Solidity,
    
        #[allow(missing_docs)]SpecmanE,
    
        #[allow(missing_docs)]Spice,
    
        #[allow(missing_docs)]Sql,
    
        #[allow(missing_docs)]Stratego,
    
        #[allow(missing_docs)]Svelte,
    
        #[allow(missing_docs)]Svg,
    
        #[allow(missing_docs)]Swift,
    
        #[allow(missing_docs)]Swig,
    
        #[allow(missing_docs)]SystemVerilog,
    
        #[allow(missing_docs)]Tcl,
    
        #[allow(missing_docs)]Tex,
    
        #[allow(missing_docs)]Text,
    
        #[allow(missing_docs)]Thrift,
    
        #[allow(missing_docs)]Toml,
    
        #[allow(missing_docs)]Tsx,
    
        #[allow(missing_docs)]Twig,
    
        #[allow(missing_docs)]TypeScript,
    
        #[allow(missing_docs)]UnrealDeveloperMarkdown,
    
        #[allow(missing_docs)]UnrealPlugin,
    
        #[allow(missing_docs)]UnrealProject,
    
        #[allow(missing_docs)]UnrealScript,
    
        #[allow(missing_docs)]UnrealShader,
    
        #[allow(missing_docs)]UnrealShaderHeader,
    
        #[allow(missing_docs)]UrWeb,
    
        #[allow(missing_docs)]UrWebProject,
    
        #[allow(missing_docs)]VB6,
    
        #[allow(missing_docs)]VBScript,
    
        #[allow(missing_docs)]Vala,
    
        #[allow(missing_docs)]Velocity,
    
        #[allow(missing_docs)]Verilog,
    
        #[allow(missing_docs)]VerilogArgsFile,
    
        #[allow(missing_docs)]Vhdl,
    
        #[allow(missing_docs)]VimScript,
    
        #[allow(missing_docs)]VisualBasic,
    
        #[allow(missing_docs)]VisualStudioProject,
    
        #[allow(missing_docs)]VisualStudioSolution,
    
        #[allow(missing_docs)]Vue,
    
        #[allow(missing_docs)]WebAssembly,
    
        #[allow(missing_docs)]Wolfram,
    
        #[allow(missing_docs)]XSL,
    
        #[allow(missing_docs)]Xaml,
    
        #[allow(missing_docs)]XcodeConfig,
    
        #[allow(missing_docs)]Xml,
    
        #[allow(missing_docs)]Xtend,
    
        #[allow(missing_docs)]Yaml,
    
        #[allow(missing_docs)]Zig,
    
        #[allow(missing_docs)]Zsh,
    
}

impl LanguageType {

    /// Returns the display name of a language.
    ///
    /// ```
    /// # use tokei::*;
    /// let bash = LanguageType::Bash;
    ///
    /// assert_eq!(bash.name(), "BASH");
    /// ```
    pub fn name(self) -> &'static str {
        match self {
                Abap =>
                
                    "ABAP"
                ,
                ActionScript =>
                
                    "ActionScript",
                Ada =>
                
                    "Ada",
                Agda =>
                
                    "Agda",
                Alex =>
                
                    "Alex",
                Arduino =>
                
                    "Arduino C++"
                ,
                Asn1 =>
                
                    "ASN.1"
                ,
                Asp =>
                
                    "ASP"
                ,
                AspNet =>
                
                    "ASP.NET"
                ,
                Assembly =>
                
                    "Assembly",
                AssemblyGAS =>
                
                    "GNU Style Assembly"
                ,
                AutoHotKey =>
                
                    "AutoHotKey",
                Autoconf =>
                
                    "Autoconf",
                Automake =>
                
                    "Automake",
                Bash =>
                
                    "BASH"
                ,
                Batch =>
                
                    "Batch",
                BrightScript =>
                
                    "BrightScript",
                C =>
                
                    "C",
                CHeader =>
                
                    "C Header"
                ,
                CMake =>
                
                    "CMake",
                CSharp =>
                
                    "C#"
                ,
                CShell =>
                
                    "C Shell"
                ,
                Cabal =>
                
                    "Cabal",
                Cassius =>
                
                    "Cassius",
                Ceylon =>
                
                    "Ceylon",
                Clojure =>
                
                    "Clojure",
                ClojureC =>
                
                    "ClojureC",
                ClojureScript =>
                
                    "ClojureScript",
                Cobol =>
                
                    "COBOL"
                ,
                CoffeeScript =>
                
                    "CoffeeScript",
                Cogent =>
                
                    "Cogent",
                ColdFusion =>
                
                    "ColdFusion",
                ColdFusionScript =>
                
                    "ColdFusion CFScript"
                ,
                Coq =>
                
                    "Coq",
                Cpp =>
                
                    "C++"
                ,
                CppHeader =>
                
                    "C++ Header"
                ,
                Crystal =>
                
                    "Crystal",
                Css =>
                
                    "CSS"
                ,
                D =>
                
                    "D",
                Dart =>
                
                    "Dart",
                DeviceTree =>
                
                    "Device Tree"
                ,
                Dhall =>
                
                    "Dhall",
                Dockerfile =>
                
                    "Dockerfile",
                DotNetResource =>
                
                    ".NET Resource"
                ,
                DreamMaker =>
                
                    "Dream Maker"
                ,
                Dust =>
                
                    "Dust.js"
                ,
                Edn =>
                
                    "Edn",
                Elisp =>
                
                    "Emacs Lisp"
                ,
                Elixir =>
                
                    "Elixir",
                Elm =>
                
                    "Elm",
                Elvish =>
                
                    "Elvish",
                EmacsDevEnv =>
                
                    "Emacs Dev Env"
                ,
                Emojicode =>
                
                    "Emojicode",
                Erlang =>
                
                    "Erlang",
                FEN =>
                
                    "FEN"
                ,
                FSharp =>
                
                    "F#"
                ,
                Fish =>
                
                    "Fish",
                FlatBuffers =>
                
                    "FlatBuffers Schema"
                ,
                Forth =>
                
                    "Forth",
                FortranLegacy =>
                
                    "FORTRAN Legacy"
                ,
                FortranModern =>
                
                    "FORTRAN Modern"
                ,
                FreeMarker =>
                
                    "FreeMarker",
                Fstar =>
                
                    "F*"
                ,
                Futhark =>
                
                    "Futhark",
                GDB =>
                
                    "GDB Script"
                ,
                GdScript =>
                
                    "GDScript"
                ,
                Gherkin =>
                
                    "Gherkin (Cucumber)"
                ,
                Glsl =>
                
                    "GLSL"
                ,
                Go =>
                
                    "Go",
                Gohtml =>
                
                    "Go HTML"
                ,
                Graphql =>
                
                    "GraphQL"
                ,
                Groovy =>
                
                    "Groovy",
                Hamlet =>
                
                    "Hamlet",
                Handlebars =>
                
                    "Handlebars",
                Happy =>
                
                    "Happy",
                Haskell =>
                
                    "Haskell",
                Haxe =>
                
                    "Haxe",
                Hcl =>
                
                    "HCL"
                ,
                Headache =>
                
                    "Headache",
                Hex =>
                
                    "HEX"
                ,
                Hlsl =>
                
                    "HLSL"
                ,
                HolyC =>
                
                    "HolyC",
                Html =>
                
                    "HTML"
                ,
                Idris =>
                
                    "Idris",
                Ini =>
                
                    "INI"
                ,
                IntelHex =>
                
                    "Intel HEX"
                ,
                Isabelle =>
                
                    "Isabelle",
                Jai =>
                
                    "JAI"
                ,
                Java =>
                
                    "Java",
                JavaScript =>
                
                    "JavaScript",
                Json =>
                
                    "JSON"
                ,
                Jsx =>
                
                    "JSX"
                ,
                Julia =>
                
                    "Julia",
                Julius =>
                
                    "Julius",
                KakouneScript =>
                
                    "Kakoune script"
                ,
                Kotlin =>
                
                    "Kotlin",
                LLVM =>
                
                    "LLVM",
                Lean =>
                
                    "Lean",
                Less =>
                
                    "LESS"
                ,
                LinkerScript =>
                
                    "LD Script"
                ,
                Liquid =>
                
                    "Liquid"
                ,
                Lisp =>
                
                    "Lisp",
                Logtalk =>
                
                    "Logtalk",
                Lua =>
                
                    "Lua",
                Lucius =>
                
                    "Lucius",
                Madlang =>
                
                    "Madlang",
                Makefile =>
                
                    "Makefile",
                Markdown =>
                
                    "Markdown",
                Meson =>
                
                    "Meson",
                Mint =>
                
                    "Mint",
                ModuleDef =>
                
                    "Module-Definition"
                ,
                MoonScript =>
                
                    "MoonScript",
                MsBuild =>
                
                    "MSBuild"
                ,
                Mustache =>
                
                    "Mustache",
                Nim =>
                
                    "Nim",
                Nix =>
                
                    "Nix",
                NotQuitePerl =>
                
                    "Not Quite Perl"
                ,
                OCaml =>
                
                    "OCaml",
                ObjectiveC =>
                
                    "Objective-C"
                ,
                ObjectiveCpp =>
                
                    "Objective-C++"
                ,
                Odin =>
                
                    "Odin",
                OpenType =>
                
                    "OpenType Feature File"
                ,
                Org =>
                
                    "Org",
                Oz =>
                
                    "Oz",
                PSL =>
                
                    "PSL Assertion"
                ,
                Pan =>
                
                    "Pan",
                Pascal =>
                
                    "Pascal",
                Perl =>
                
                    "Perl",
                Perl6 =>
                
                    "Rakudo"
                ,
                Pest =>
                
                    "Pest",
                Php =>
                
                    "PHP"
                ,
                Polly =>
                
                    "Polly",
                Pony =>
                
                    "Pony",
                PostCss =>
                
                    "PostCSS"
                ,
                PowerShell =>
                
                    "PowerShell",
                Processing =>
                
                    "Processing",
                Prolog =>
                
                    "Prolog",
                Protobuf =>
                
                    "Protocol Buffers"
                ,
                PureScript =>
                
                    "PureScript",
                Python =>
                
                    "Python",
                Qcl =>
                
                    "QCL"
                ,
                Qml =>
                
                    "QML"
                ,
                R =>
                
                    "R",
                RON =>
                
                    "Rusty Object Notation"
                ,
                RPMSpecfile =>
                
                    "RPM Specfile"
                ,
                Racket =>
                
                    "Racket",
                Rakefile =>
                
                    "Rakefile",
                Razor =>
                
                    "Razor",
                ReStructuredText =>
                
                    "ReStructuredText",
                Renpy =>
                
                    "Ren'Py"
                ,
                Ruby =>
                
                    "Ruby",
                RubyHtml =>
                
                    "Ruby HTML"
                ,
                Rust =>
                
                    "Rust",
                SRecode =>
                
                    "SRecode Template"
                ,
                Sass =>
                
                    "Sass",
                Scala =>
                
                    "Scala",
                Scheme =>
                
                    "Scheme",
                Scons =>
                
                    "Scons",
                Sh =>
                
                    "Shell"
                ,
                Sml =>
                
                    "Standard ML (SML)"
                ,
                Solidity =>
                
                    "Solidity"
                ,
                SpecmanE =>
                
                    "Specman e"
                ,
                Spice =>
                
                    "Spice Netlist"
                ,
                Sql =>
                
                    "SQL"
                ,
                Stratego =>
                
                    "Stratego/XT"
                ,
                Svelte =>
                
                    "Svelte",
                Svg =>
                
                    "SVG"
                ,
                Swift =>
                
                    "Swift",
                Swig =>
                
                    "SWIG"
                ,
                SystemVerilog =>
                
                    "SystemVerilog",
                Tcl =>
                
                    "TCL"
                ,
                Tex =>
                
                    "TeX"
                ,
                Text =>
                
                    "Plain Text"
                ,
                Thrift =>
                
                    "Thrift",
                Toml =>
                
                    "TOML"
                ,
                Tsx =>
                
                    "TSX"
                ,
                Twig =>
                
                    "Twig"
                ,
                TypeScript =>
                
                    "TypeScript",
                UnrealDeveloperMarkdown =>
                
                    "Unreal Markdown"
                ,
                UnrealPlugin =>
                
                    "Unreal Plugin"
                ,
                UnrealProject =>
                
                    "Unreal Project"
                ,
                UnrealScript =>
                
                    "Unreal Script"
                ,
                UnrealShader =>
                
                    "Unreal Shader"
                ,
                UnrealShaderHeader =>
                
                    "Unreal Shader Header"
                ,
                UrWeb =>
                
                    "Ur/Web"
                ,
                UrWebProject =>
                
                    "Ur/Web Project"
                ,
                VB6 =>
                
                    "VB6"
                ,
                VBScript =>
                
                    "VBScript"
                ,
                Vala =>
                
                    "Vala",
                Velocity =>
                
                    "Apache Velocity"
                ,
                Verilog =>
                
                    "Verilog",
                VerilogArgsFile =>
                
                    "Verilog Args File"
                ,
                Vhdl =>
                
                    "VHDL"
                ,
                VimScript =>
                
                    "Vim Script"
                ,
                VisualBasic =>
                
                    "Visual Basic"
                ,
                VisualStudioProject =>
                
                    "Visual Studio Project"
                ,
                VisualStudioSolution =>
                
                    "Visual Studio Solution"
                ,
                Vue =>
                
                    "Vue"
                ,
                WebAssembly =>
                
                    "WebAssembly",
                Wolfram =>
                
                    "Wolfram",
                XSL =>
                
                    "XSL"
                ,
                Xaml =>
                
                    "XAML"
                ,
                XcodeConfig =>
                
                    "Xcode Config"
                ,
                Xml =>
                
                    "XML"
                ,
                Xtend =>
                
                    "Xtend",
                Yaml =>
                
                    "YAML"
                ,
                Zig =>
                
                    "Zig",
                Zsh =>
                
                    "Zsh",
        }
    }

    pub(crate) fn is_blank(self) -> bool {
        match self {
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    FEN => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    Hex => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
                    IntelHex => true,
                
            
                
            
                
            
                
            
                
            
                
                    Json => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    Markdown => true,
                
            
                
            
                
                    Mint => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    ReStructuredText => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    Text => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
                    UnrealDeveloperMarkdown => true,
                
            
                
                    UnrealPlugin => true,
                
            
                
                    UnrealProject => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    VisualStudioSolution => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
            _ => false,
        }
    }

    pub(crate) fn is_fortran(self) -> bool {
        self == LanguageType::FortranModern ||
        self == LanguageType::FortranLegacy
    }

    /// Provides every variant in a Vec
    pub fn list() -> &'static [Self] {
        &[
            
                Abap,
                ActionScript,
                Ada,
                Agda,
                Alex,
                Arduino,
                Asn1,
                Asp,
                AspNet,
                Assembly,
                AssemblyGAS,
                AutoHotKey,
                Autoconf,
                Automake,
                Bash,
                Batch,
                BrightScript,
                C,
                CHeader,
                CMake,
                CSharp,
                CShell,
                Cabal,
                Cassius,
                Ceylon,
                Clojure,
                ClojureC,
                ClojureScript,
                Cobol,
                CoffeeScript,
                Cogent,
                ColdFusion,
                ColdFusionScript,
                Coq,
                Cpp,
                CppHeader,
                Crystal,
                Css,
                D,
                Dart,
                DeviceTree,
                Dhall,
                Dockerfile,
                DotNetResource,
                DreamMaker,
                Dust,
                Edn,
                Elisp,
                Elixir,
                Elm,
                Elvish,
                EmacsDevEnv,
                Emojicode,
                Erlang,
                FEN,
                FSharp,
                Fish,
                FlatBuffers,
                Forth,
                FortranLegacy,
                FortranModern,
                FreeMarker,
                Fstar,
                Futhark,
                GDB,
                GdScript,
                Gherkin,
                Glsl,
                Go,
                Gohtml,
                Graphql,
                Groovy,
                Hamlet,
                Handlebars,
                Happy,
                Haskell,
                Haxe,
                Hcl,
                Headache,
                Hex,
                Hlsl,
                HolyC,
                Html,
                Idris,
                Ini,
                IntelHex,
                Isabelle,
                Jai,
                Java,
                JavaScript,
                Json,
                Jsx,
                Julia,
                Julius,
                KakouneScript,
                Kotlin,
                LLVM,
                Lean,
                Less,
                LinkerScript,
                Liquid,
                Lisp,
                Logtalk,
                Lua,
                Lucius,
                Madlang,
                Makefile,
                Markdown,
                Meson,
                Mint,
                ModuleDef,
                MoonScript,
                MsBuild,
                Mustache,
                Nim,
                Nix,
                NotQuitePerl,
                OCaml,
                ObjectiveC,
                ObjectiveCpp,
                Odin,
                OpenType,
                Org,
                Oz,
                PSL,
                Pan,
                Pascal,
                Perl,
                Perl6,
                Pest,
                Php,
                Polly,
                Pony,
                PostCss,
                PowerShell,
                Processing,
                Prolog,
                Protobuf,
                PureScript,
                Python,
                Qcl,
                Qml,
                R,
                RON,
                RPMSpecfile,
                Racket,
                Rakefile,
                Razor,
                ReStructuredText,
                Renpy,
                Ruby,
                RubyHtml,
                Rust,
                SRecode,
                Sass,
                Scala,
                Scheme,
                Scons,
                Sh,
                Sml,
                Solidity,
                SpecmanE,
                Spice,
                Sql,
                Stratego,
                Svelte,
                Svg,
                Swift,
                Swig,
                SystemVerilog,
                Tcl,
                Tex,
                Text,
                Thrift,
                Toml,
                Tsx,
                Twig,
                TypeScript,
                UnrealDeveloperMarkdown,
                UnrealPlugin,
                UnrealProject,
                UnrealScript,
                UnrealShader,
                UnrealShaderHeader,
                UrWeb,
                UrWebProject,
                VB6,
                VBScript,
                Vala,
                Velocity,
                Verilog,
                VerilogArgsFile,
                Vhdl,
                VimScript,
                VisualBasic,
                VisualStudioProject,
                VisualStudioSolution,
                Vue,
                WebAssembly,
                Wolfram,
                XSL,
                Xaml,
                XcodeConfig,
                Xml,
                Xtend,
                Yaml,
                Zig,
                Zsh,
        ]
    }

    /// Returns the single line comments of a language.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::Rust;
    /// assert_eq!(lang.line_comments(), &["//"]);
    /// ```
    pub fn line_comments(self) -> &'static [&'static str] {
        match self {
            
                Abap =>
                        &[
                                "*",
                                "\"",
                        ],
                ActionScript =>
                        &[
                                "//",
                        ],
                Ada =>
                        &[
                                "--",
                        ],
                Agda =>
                        &[
                                "--",
                        ],
                
                Arduino =>
                        &[
                                "//",
                        ],
                Asn1 =>
                        &[
                                "--",
                        ],
                Asp =>
                        &[
                                "'",
                                "REM",
                        ],
                
                Assembly =>
                        &[
                                ";",
                        ],
                AssemblyGAS =>
                        &[
                                "//",
                        ],
                AutoHotKey =>
                        &[
                                ";",
                        ],
                Autoconf =>
                        &[
                                "#",
                                "dnl",
                        ],
                Automake =>
                        &[
                                "#",
                        ],
                Bash =>
                        &[
                                "#",
                        ],
                Batch =>
                        &[
                                "REM",
                                "::",
                        ],
                BrightScript =>
                        &[
                                "'",
                                "REM",
                        ],
                C =>
                        &[
                                "//",
                        ],
                CHeader =>
                        &[
                                "//",
                        ],
                CMake =>
                        &[
                                "#",
                        ],
                CSharp =>
                        &[
                                "//",
                        ],
                CShell =>
                        &[
                                "#",
                        ],
                Cabal =>
                        &[
                                "--",
                        ],
                Cassius =>
                        &[
                                "//",
                        ],
                Ceylon =>
                        &[
                                "//",
                        ],
                Clojure =>
                        &[
                                ";",
                        ],
                ClojureC =>
                        &[
                                ";",
                        ],
                ClojureScript =>
                        &[
                                ";",
                        ],
                Cobol =>
                        &[
                                "*",
                        ],
                CoffeeScript =>
                        &[
                                "#",
                        ],
                Cogent =>
                        &[
                                "--",
                        ],
                
                ColdFusionScript =>
                        &[
                                "//",
                        ],
                
                Cpp =>
                        &[
                                "//",
                        ],
                CppHeader =>
                        &[
                                "//",
                        ],
                Crystal =>
                        &[
                                "#",
                        ],
                Css =>
                        &[
                                "//",
                        ],
                D =>
                        &[
                                "//",
                        ],
                Dart =>
                        &[
                                "//",
                        ],
                DeviceTree =>
                        &[
                                "//",
                        ],
                Dhall =>
                        &[
                                "--",
                        ],
                Dockerfile =>
                        &[
                                "#",
                        ],
                
                DreamMaker =>
                        &[
                                "//",
                        ],
                
                Edn =>
                        &[
                                ";",
                        ],
                Elisp =>
                        &[
                                ";",
                        ],
                Elixir =>
                        &[
                                "#",
                        ],
                Elm =>
                        &[
                                "--",
                        ],
                Elvish =>
                        &[
                                "#",
                        ],
                EmacsDevEnv =>
                        &[
                                ";",
                        ],
                Emojicode =>
                        &[
                                "💭",
                        ],
                Erlang =>
                        &[
                                "%",
                        ],
                
                FSharp =>
                        &[
                                "//",
                        ],
                Fish =>
                        &[
                                "#",
                        ],
                FlatBuffers =>
                        &[
                                "//",
                        ],
                Forth =>
                        &[
                                "\\",
                        ],
                FortranLegacy =>
                        &[
                                "c",
                                "C",
                                "!",
                                "*",
                        ],
                FortranModern =>
                        &[
                                "!",
                        ],
                
                
                Futhark =>
                        &[
                                "--",
                        ],
                GDB =>
                        &[
                                "#",
                        ],
                GdScript =>
                        &[
                                "#",
                        ],
                Gherkin =>
                        &[
                                "#",
                        ],
                Glsl =>
                        &[
                                "//",
                        ],
                Go =>
                        &[
                                "//",
                        ],
                
                Graphql =>
                        &[
                                "#",
                        ],
                Groovy =>
                        &[
                                "//",
                        ],
                
                
                
                Haskell =>
                        &[
                                "--",
                        ],
                Haxe =>
                        &[
                                "//",
                        ],
                Hcl =>
                        &[
                                "#",
                                "//",
                        ],
                Headache =>
                        &[
                                "//",
                        ],
                
                Hlsl =>
                        &[
                                "//",
                        ],
                HolyC =>
                        &[
                                "//",
                        ],
                Html =>
                        &[
                                "//",
                        ],
                Idris =>
                        &[
                                "--",
                        ],
                Ini =>
                        &[
                                ";",
                                "#",
                        ],
                
                Isabelle =>
                        &[
                                "--",
                        ],
                Jai =>
                        &[
                                "//",
                        ],
                Java =>
                        &[
                                "//",
                        ],
                JavaScript =>
                        &[
                                "//",
                        ],
                
                Jsx =>
                        &[
                                "//",
                        ],
                Julia =>
                        &[
                                "#",
                        ],
                Julius =>
                        &[
                                "//",
                        ],
                KakouneScript =>
                        &[
                                "#",
                        ],
                Kotlin =>
                        &[
                                "//",
                        ],
                LLVM =>
                        &[
                                ";",
                        ],
                Lean =>
                        &[
                                "--",
                        ],
                Less =>
                        &[
                                "//",
                        ],
                LinkerScript =>
                        &[
                                "//",
                        ],
                
                Lisp =>
                        &[
                                ";",
                        ],
                Logtalk =>
                        &[
                                "%",
                        ],
                Lua =>
                        &[
                                "--",
                        ],
                Lucius =>
                        &[
                                "//",
                        ],
                Madlang =>
                        &[
                                "#",
                        ],
                Makefile =>
                        &[
                                "#",
                        ],
                
                Meson =>
                        &[
                                "#",
                        ],
                
                ModuleDef =>
                        &[
                                ";",
                        ],
                MoonScript =>
                        &[
                                "--",
                        ],
                
                
                Nim =>
                        &[
                                "#",
                        ],
                Nix =>
                        &[
                                "#",
                        ],
                NotQuitePerl =>
                        &[
                                "#",
                        ],
                
                ObjectiveC =>
                        &[
                                "//",
                        ],
                ObjectiveCpp =>
                        &[
                                "//",
                        ],
                Odin =>
                        &[
                                "//",
                        ],
                OpenType =>
                        &[
                                "#",
                        ],
                Org =>
                        &[
                                "# ",
                        ],
                Oz =>
                        &[
                                "%",
                        ],
                PSL =>
                        &[
                                "//",
                        ],
                Pan =>
                        &[
                                "#",
                        ],
                Pascal =>
                        &[
                                "//",
                        ],
                Perl =>
                        &[
                                "#",
                        ],
                Perl6 =>
                        &[
                                "#",
                        ],
                Pest =>
                        &[
                                "//",
                        ],
                Php =>
                        &[
                                "#",
                                "//",
                        ],
                
                Pony =>
                        &[
                                "//",
                        ],
                PostCss =>
                        &[
                                "//",
                        ],
                PowerShell =>
                        &[
                                "#",
                        ],
                Processing =>
                        &[
                                "//",
                        ],
                Prolog =>
                        &[
                                "%",
                        ],
                Protobuf =>
                        &[
                                "//",
                        ],
                PureScript =>
                        &[
                                "--",
                        ],
                Python =>
                        &[
                                "#",
                        ],
                Qcl =>
                        &[
                                "//",
                        ],
                Qml =>
                        &[
                                "//",
                        ],
                R =>
                        &[
                                "#",
                        ],
                RON =>
                        &[
                                "//",
                        ],
                RPMSpecfile =>
                        &[
                                "#",
                        ],
                Racket =>
                        &[
                                ";",
                        ],
                Rakefile =>
                        &[
                                "#",
                        ],
                
                
                Renpy =>
                        &[
                                "#",
                        ],
                Ruby =>
                        &[
                                "#",
                        ],
                
                Rust =>
                        &[
                                "//",
                        ],
                SRecode =>
                        &[
                                ";;",
                        ],
                Sass =>
                        &[
                                "//",
                        ],
                Scala =>
                        &[
                                "//",
                        ],
                Scheme =>
                        &[
                                ";",
                        ],
                Scons =>
                        &[
                                "#",
                        ],
                Sh =>
                        &[
                                "#",
                        ],
                
                Solidity =>
                        &[
                                "//",
                        ],
                SpecmanE =>
                        &[
                                "--",
                                "//",
                        ],
                Spice =>
                        &[
                                "*",
                        ],
                Sql =>
                        &[
                                "--",
                        ],
                Stratego =>
                        &[
                                "//",
                        ],
                Svelte =>
                        &[
                                "//",
                        ],
                
                Swift =>
                        &[
                                "//",
                        ],
                Swig =>
                        &[
                                "//",
                        ],
                SystemVerilog =>
                        &[
                                "//",
                        ],
                Tcl =>
                        &[
                                "#",
                        ],
                Tex =>
                        &[
                                "%",
                        ],
                
                Thrift =>
                        &[
                                "#",
                                "//",
                        ],
                Toml =>
                        &[
                                "#",
                        ],
                Tsx =>
                        &[
                                "//",
                        ],
                
                TypeScript =>
                        &[
                                "//",
                        ],
                
                
                
                UnrealScript =>
                        &[
                                "//",
                        ],
                UnrealShader =>
                        &[
                                "//",
                        ],
                UnrealShaderHeader =>
                        &[
                                "//",
                        ],
                
                UrWebProject =>
                        &[
                                "#",
                        ],
                VB6 =>
                        &[
                                "'",
                        ],
                VBScript =>
                        &[
                                "'",
                                "REM",
                        ],
                Vala =>
                        &[
                                "//",
                        ],
                Velocity =>
                        &[
                                "##",
                        ],
                Verilog =>
                        &[
                                "//",
                        ],
                
                Vhdl =>
                        &[
                                "--",
                        ],
                VimScript =>
                        &[
                                "\"",
                        ],
                VisualBasic =>
                        &[
                                "'",
                        ],
                
                
                Vue =>
                        &[
                                "//",
                        ],
                WebAssembly =>
                        &[
                                ";;",
                        ],
                
                
                
                XcodeConfig =>
                        &[
                                "//",
                        ],
                
                Xtend =>
                        &[
                                "//",
                        ],
                Yaml =>
                        &[
                                "#",
                        ],
                Zig =>
                        &[
                                "//",
                        ],
                Zsh =>
                        &[
                                "#",
                        ],
            _ => &[],
        }
    }

    /// Returns the single line comments of a language.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::Rust;
    /// assert_eq!(lang.multi_line_comments(), &[("/*", "*/")]);
    /// ```
    pub fn multi_line_comments(self) -> &'static [(&'static str, &'static str)]
    {
        match self {
            
                    
                    ActionScript =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Agda =>
                        &[
                                (
                                    "{-",
                                    "-}",
                                ),
                        ],
                    
                    Arduino =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Asn1 =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    AspNet =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                                (
                                    "<%--",
                                    "-->",
                                ),
                        ],
                    
                    AssemblyGAS =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    AutoHotKey =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    
                    
                    
                    
                    C =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    CHeader =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    CSharp =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Cabal =>
                        &[
                                (
                                    "{-",
                                    "-}",
                                ),
                        ],
                    Cassius =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Ceylon =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    
                    
                    
                    CoffeeScript =>
                        &[
                                (
                                    "###",
                                    "###",
                                ),
                        ],
                    
                    ColdFusion =>
                        &[
                                (
                                    "<!---",
                                    "--->",
                                ),
                        ],
                    ColdFusionScript =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Coq =>
                        &[
                                (
                                    "(*",
                                    "*)",
                                ),
                        ],
                    Cpp =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    CppHeader =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Css =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    D =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Dart =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    DeviceTree =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Dhall =>
                        &[
                                (
                                    "{-",
                                    "-}",
                                ),
                        ],
                    
                    DotNetResource =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    DreamMaker =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Dust =>
                        &[
                                (
                                    "{!",
                                    "!}",
                                ),
                        ],
                    
                    
                    
                    Elm =>
                        &[
                                (
                                    "{-",
                                    "-}",
                                ),
                        ],
                    
                    
                    Emojicode =>
                        &[
                                (
                                    "💭🔜",
                                    "🔚💭",
                                ),
                                (
                                    "📗",
                                    "📗",
                                ),
                                (
                                    "📘",
                                    "📘",
                                ),
                        ],
                    
                    
                    FSharp =>
                        &[
                                (
                                    "(*",
                                    "*)",
                                ),
                        ],
                    
                    FlatBuffers =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Forth =>
                        &[
                                (
                                    "( ",
                                    ")",
                                ),
                        ],
                    
                    
                    FreeMarker =>
                        &[
                                (
                                    "<#--",
                                    "-->",
                                ),
                        ],
                    Fstar =>
                        &[
                                (
                                    "(*",
                                    "*)",
                                ),
                        ],
                    
                    
                    
                    
                    Glsl =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Go =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Gohtml =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                                (
                                    "{{/*",
                                    "*/}}",
                                ),
                        ],
                    
                    Groovy =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Hamlet =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    Handlebars =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                                (
                                    "{{!",
                                    "}}",
                                ),
                        ],
                    
                    Haskell =>
                        &[
                                (
                                    "{-",
                                    "-}",
                                ),
                        ],
                    Haxe =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Hcl =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Headache =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Hlsl =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    HolyC =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Html =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Idris =>
                        &[
                                (
                                    "{-",
                                    "-}",
                                ),
                        ],
                    
                    
                    Isabelle =>
                        &[
                                (
                                    "{*",
                                    "*}",
                                ),
                                (
                                    "(*",
                                    "*)",
                                ),
                                (
                                    "‹",
                                    "›",
                                ),
                                (
                                    "\\<open>",
                                    "\\<close>",
                                ),
                        ],
                    Jai =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Java =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    JavaScript =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Jsx =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Julia =>
                        &[
                                (
                                    "#=",
                                    "=#",
                                ),
                        ],
                    Julius =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Kotlin =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Lean =>
                        &[
                                (
                                    "/-",
                                    "-/",
                                ),
                        ],
                    Less =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    LinkerScript =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Liquid =>
                        &[
                                (
                                    "{% comment %}",
                                    "{% endcomment %}",
                                ),
                        ],
                    Lisp =>
                        &[
                                (
                                    "#|",
                                    "|#",
                                ),
                        ],
                    Logtalk =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Lua =>
                        &[
                                (
                                    "--[[",
                                    "]]",
                                ),
                        ],
                    Lucius =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Madlang =>
                        &[
                                (
                                    "{#",
                                    "#}",
                                ),
                        ],
                    
                    
                    
                    
                    
                    
                    MsBuild =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    Mustache =>
                        &[
                                (
                                    "{{!",
                                    "}}",
                                ),
                        ],
                    
                    Nix =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    NotQuitePerl =>
                        &[
                                (
                                    "=begin",
                                    "=end",
                                ),
                        ],
                    OCaml =>
                        &[
                                (
                                    "(*",
                                    "*)",
                                ),
                        ],
                    ObjectiveC =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    ObjectiveCpp =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Odin =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    
                    Oz =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    PSL =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Pascal =>
                        &[
                                (
                                    "{",
                                    "}",
                                ),
                                (
                                    "(*",
                                    "*)",
                                ),
                        ],
                    Perl =>
                        &[
                                (
                                    "=pod",
                                    "=cut",
                                ),
                        ],
                    Perl6 =>
                        &[
                                (
                                    "=begin",
                                    "=end",
                                ),
                        ],
                    
                    Php =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Polly =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    Pony =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    PostCss =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    PowerShell =>
                        &[
                                (
                                    "<#",
                                    "#>",
                                ),
                        ],
                    Processing =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Prolog =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    PureScript =>
                        &[
                                (
                                    "{-",
                                    "-}",
                                ),
                        ],
                    
                    Qcl =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Qml =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    RON =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Racket =>
                        &[
                                (
                                    "#|",
                                    "|#",
                                ),
                        ],
                    Rakefile =>
                        &[
                                (
                                    "=begin",
                                    "=end",
                                ),
                        ],
                    Razor =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                                (
                                    "@*",
                                    "*@",
                                ),
                        ],
                    
                    
                    Ruby =>
                        &[
                                (
                                    "=begin",
                                    "=end",
                                ),
                        ],
                    RubyHtml =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    Rust =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Sass =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Scala =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Scheme =>
                        &[
                                (
                                    "#|",
                                    "|#",
                                ),
                        ],
                    
                    
                    Sml =>
                        &[
                                (
                                    "(*",
                                    "*)",
                                ),
                        ],
                    Solidity =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    SpecmanE =>
                        &[
                                (
                                    "'>",
                                    "<'",
                                ),
                        ],
                    
                    Sql =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Stratego =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Svelte =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    Svg =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    Swift =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Swig =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    SystemVerilog =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    
                    
                    Thrift =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Tsx =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Twig =>
                        &[
                                (
                                    "{#",
                                    "#}",
                                ),
                        ],
                    TypeScript =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    
                    
                    UnrealScript =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    UnrealShader =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    UnrealShaderHeader =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    UrWeb =>
                        &[
                                (
                                    "(*",
                                    "*)",
                                ),
                        ],
                    
                    
                    
                    Vala =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Velocity =>
                        &[
                                (
                                    "#*",
                                    "*#",
                                ),
                        ],
                    Verilog =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    
                    
                    
                    VisualStudioProject =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    
                    Vue =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    Wolfram =>
                        &[
                                (
                                    "(*",
                                    "*)",
                                ),
                        ],
                    XSL =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    Xaml =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    
                    Xml =>
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                        ],
                    Xtend =>
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    
                    
                    
            _ => &[],
        }
    }


    /// Returns whether the language allows nested multi line comments.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::Rust;
    /// assert!(lang.allows_nested());
    /// ```
    pub fn allows_nested(self) -> bool {
        match self {
            Agda => true,Cabal => true,Dhall => true,DreamMaker => true,Elm => true,Haskell => true,Idris => true,Jai => true,Julia => true,Kotlin => true,Lean => true,Lisp => true,Pascal => true,PureScript => true,RON => true,Racket => true,Rust => true,Scheme => true,Swift => true,Swig => true,
            _ => false,
        }
    }

    /// Returns what nested comments the language has. (Currently only D has
    /// any of this type.)
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::D;
    /// assert_eq!(lang.nested_comments(), &[("/+", "+/")]);
    /// ```
    pub fn nested_comments(self) -> &'static [(&'static str, &'static str)]
    {
        match self {
            Abap => &[
                ],ActionScript => &[
                ],Ada => &[
                ],Agda => &[
                ],Alex => &[
                ],Arduino => &[
                ],Asn1 => &[
                ],Asp => &[
                ],AspNet => &[
                ],Assembly => &[
                ],AssemblyGAS => &[
                ],AutoHotKey => &[
                ],Autoconf => &[
                ],Automake => &[
                ],Bash => &[
                ],Batch => &[
                ],BrightScript => &[
                ],C => &[
                ],CHeader => &[
                ],CMake => &[
                ],CSharp => &[
                ],CShell => &[
                ],Cabal => &[
                ],Cassius => &[
                ],Ceylon => &[
                ],Clojure => &[
                ],ClojureC => &[
                ],ClojureScript => &[
                ],Cobol => &[
                ],CoffeeScript => &[
                ],Cogent => &[
                ],ColdFusion => &[
                ],ColdFusionScript => &[
                ],Coq => &[
                ],Cpp => &[
                ],CppHeader => &[
                ],Crystal => &[
                ],Css => &[
                ],D => &[
                    ( "/+", "+/",
                    ),
                ],Dart => &[
                ],DeviceTree => &[
                ],Dhall => &[
                ],Dockerfile => &[
                ],DotNetResource => &[
                ],DreamMaker => &[
                ],Dust => &[
                ],Edn => &[
                ],Elisp => &[
                ],Elixir => &[
                ],Elm => &[
                ],Elvish => &[
                ],EmacsDevEnv => &[
                ],Emojicode => &[
                ],Erlang => &[
                ],FEN => &[
                ],FSharp => &[
                ],Fish => &[
                ],FlatBuffers => &[
                ],Forth => &[
                ],FortranLegacy => &[
                ],FortranModern => &[
                ],FreeMarker => &[
                ],Fstar => &[
                ],Futhark => &[
                ],GDB => &[
                ],GdScript => &[
                ],Gherkin => &[
                ],Glsl => &[
                ],Go => &[
                ],Gohtml => &[
                ],Graphql => &[
                ],Groovy => &[
                ],Hamlet => &[
                ],Handlebars => &[
                ],Happy => &[
                ],Haskell => &[
                ],Haxe => &[
                ],Hcl => &[
                ],Headache => &[
                ],Hex => &[
                ],Hlsl => &[
                ],HolyC => &[
                ],Html => &[
                ],Idris => &[
                ],Ini => &[
                ],IntelHex => &[
                ],Isabelle => &[
                ],Jai => &[
                ],Java => &[
                ],JavaScript => &[
                ],Json => &[
                ],Jsx => &[
                ],Julia => &[
                ],Julius => &[
                ],KakouneScript => &[
                ],Kotlin => &[
                ],LLVM => &[
                ],Lean => &[
                ],Less => &[
                ],LinkerScript => &[
                ],Liquid => &[
                ],Lisp => &[
                ],Logtalk => &[
                ],Lua => &[
                ],Lucius => &[
                ],Madlang => &[
                ],Makefile => &[
                ],Markdown => &[
                ],Meson => &[
                ],Mint => &[
                ],ModuleDef => &[
                ],MoonScript => &[
                ],MsBuild => &[
                ],Mustache => &[
                ],Nim => &[
                ],Nix => &[
                ],NotQuitePerl => &[
                ],OCaml => &[
                ],ObjectiveC => &[
                ],ObjectiveCpp => &[
                ],Odin => &[
                ],OpenType => &[
                ],Org => &[
                ],Oz => &[
                ],PSL => &[
                ],Pan => &[
                ],Pascal => &[
                ],Perl => &[
                ],Perl6 => &[
                ],Pest => &[
                ],Php => &[
                ],Polly => &[
                ],Pony => &[
                ],PostCss => &[
                ],PowerShell => &[
                ],Processing => &[
                ],Prolog => &[
                ],Protobuf => &[
                ],PureScript => &[
                ],Python => &[
                ],Qcl => &[
                ],Qml => &[
                ],R => &[
                ],RON => &[
                ],RPMSpecfile => &[
                ],Racket => &[
                ],Rakefile => &[
                ],Razor => &[
                ],ReStructuredText => &[
                ],Renpy => &[
                ],Ruby => &[
                ],RubyHtml => &[
                ],Rust => &[
                ],SRecode => &[
                ],Sass => &[
                ],Scala => &[
                ],Scheme => &[
                ],Scons => &[
                ],Sh => &[
                ],Sml => &[
                ],Solidity => &[
                ],SpecmanE => &[
                ],Spice => &[
                ],Sql => &[
                ],Stratego => &[
                ],Svelte => &[
                ],Svg => &[
                ],Swift => &[
                ],Swig => &[
                ],SystemVerilog => &[
                ],Tcl => &[
                ],Tex => &[
                ],Text => &[
                ],Thrift => &[
                ],Toml => &[
                ],Tsx => &[
                ],Twig => &[
                ],TypeScript => &[
                ],UnrealDeveloperMarkdown => &[
                ],UnrealPlugin => &[
                ],UnrealProject => &[
                ],UnrealScript => &[
                ],UnrealShader => &[
                ],UnrealShaderHeader => &[
                ],UrWeb => &[
                ],UrWebProject => &[
                ],VB6 => &[
                ],VBScript => &[
                ],Vala => &[
                ],Velocity => &[
                ],Verilog => &[
                ],VerilogArgsFile => &[
                ],Vhdl => &[
                ],VimScript => &[
                ],VisualBasic => &[
                ],VisualStudioProject => &[
                ],VisualStudioSolution => &[
                ],Vue => &[
                ],WebAssembly => &[
                ],Wolfram => &[
                ],XSL => &[
                ],Xaml => &[
                ],XcodeConfig => &[
                ],Xml => &[
                ],Xtend => &[
                ],Yaml => &[
                ],Zig => &[
                ],Zsh => &[
                ],
        }
    }

    /// Returns the quotes of a language.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::C;
    /// assert_eq!(lang.quotes(), &[("\"", "\"")]);
    /// ```
    pub fn quotes(self) -> &'static [(&'static str, &'static str)] {
        match self {
            
                
                ActionScript =>
                        &[
                                ("\"","\"", ),
                        ],
                
                
                
                Arduino =>
                        &[
                                ("\"","\"", ),
                        ],
                Asn1 =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                
                Assembly =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                AssemblyGAS =>
                        &[
                                ("\"","\"", ),
                        ],
                
                
                
                Bash =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                BrightScript =>
                        &[
                                ("\"","\"", ),
                        ],
                C =>
                        &[
                                ("\"","\"", ),
                        ],
                CHeader =>
                        &[
                                ("\"","\"", ),
                        ],
                CMake =>
                        &[
                                ("\"","\"", ),
                        ],
                CSharp =>
                        &[
                                ("\"","\"", ),
                        ],
                
                
                Cassius =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Ceylon =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("\"","\"", ),
                        ],
                Clojure =>
                        &[
                                ("\"","\"", ),
                        ],
                ClojureC =>
                        &[
                                ("\"","\"", ),
                        ],
                ClojureScript =>
                        &[
                                ("\"","\"", ),
                        ],
                
                CoffeeScript =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                ColdFusion =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                ColdFusionScript =>
                        &[
                                ("\"","\"", ),
                        ],
                Coq =>
                        &[
                                ("\"","\"", ),
                        ],
                Cpp =>
                        &[
                                ("\"","\"", ),
                        ],
                CppHeader =>
                        &[
                                ("\"","\"", ),
                        ],
                Crystal =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Css =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                D =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Dart =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("'''","'''", ),
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                DeviceTree =>
                        &[
                                ("\"","\"", ),
                        ],
                Dhall =>
                        &[
                                ("\"","\"", ),
                                ("''","''", ),
                        ],
                Dockerfile =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                DotNetResource =>
                        &[
                                ("\"","\"", ),
                        ],
                DreamMaker =>
                        &[
                                ("{\"","\"}", ),
                                ("'","'", ),
                        ],
                
                
                
                Elixir =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("'''","'''", ),
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                Elvish =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                Emojicode =>
                        &[
                                ("❌🔤","❌🔤", ),
                        ],
                
                
                FSharp =>
                        &[
                                ("\"","\"", ),
                        ],
                Fish =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                FlatBuffers =>
                        &[
                                ("\"","\"", ),
                        ],
                
                FortranLegacy =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                FortranModern =>
                        &[
                                ("\"","\"", ),
                        ],
                
                Fstar =>
                        &[
                                ("\"","\"", ),
                        ],
                
                
                GdScript =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                Glsl =>
                        &[
                                ("\"","\"", ),
                        ],
                Go =>
                        &[
                                ("\"","\"", ),
                        ],
                Gohtml =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Graphql =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("\"","\"", ),
                        ],
                Groovy =>
                        &[
                                ("\"","\"", ),
                        ],
                Hamlet =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Handlebars =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                
                Haxe =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Hcl =>
                        &[
                                ("\"","\"", ),
                        ],
                Headache =>
                        &[
                                ("\"","\"", ),
                        ],
                
                Hlsl =>
                        &[
                                ("\"","\"", ),
                        ],
                HolyC =>
                        &[
                                ("\"","\"", ),
                        ],
                Html =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                                ("`","`", ),
                        ],
                Idris =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("\"","\"", ),
                        ],
                
                
                Isabelle =>
                        &[
                                ("''","''", ),
                        ],
                Jai =>
                        &[
                                ("\"","\"", ),
                        ],
                Java =>
                        &[
                                ("\"","\"", ),
                        ],
                JavaScript =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                                ("`","`", ),
                        ],
                
                Jsx =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                                ("`","`", ),
                        ],
                Julia =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("\"","\"", ),
                        ],
                Julius =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                                ("`","`", ),
                        ],
                KakouneScript =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Kotlin =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("\"","\"", ),
                        ],
                LLVM =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                Less =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                LinkerScript =>
                        &[
                                ("\"","\"", ),
                        ],
                Liquid =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                Logtalk =>
                        &[
                                ("\"","\"", ),
                        ],
                Lua =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Lucius =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                
                
                Meson =>
                        &[
                                ("'''","'''", ),
                                ("'","'", ),
                        ],
                
                
                MoonScript =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                MsBuild =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Mustache =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Nim =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("\"","\"", ),
                        ],
                Nix =>
                        &[
                                ("\"","\"", ),
                        ],
                NotQuitePerl =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                OCaml =>
                        &[
                                ("\"","\"", ),
                        ],
                ObjectiveC =>
                        &[
                                ("\"","\"", ),
                        ],
                ObjectiveCpp =>
                        &[
                                ("\"","\"", ),
                        ],
                Odin =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                
                Oz =>
                        &[
                                ("\"","\"", ),
                        ],
                PSL =>
                        &[
                                ("\"","\"", ),
                        ],
                Pan =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Pascal =>
                        &[
                                ("'","'", ),
                        ],
                Perl =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Perl6 =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Pest =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Php =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Polly =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Pony =>
                        &[
                                ("\"","\"", ),
                        ],
                PostCss =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                PowerShell =>
                        &[
                                ("\"@","@\"", ),
                                ("\"","\"", ),
                                ("@'","'@", ),
                                ("'","'", ),
                        ],
                Processing =>
                        &[
                                ("\"","\"", ),
                        ],
                Prolog =>
                        &[
                                ("\"","\"", ),
                        ],
                
                
                Python =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Qcl =>
                        &[
                                ("\"","\"", ),
                        ],
                Qml =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                RON =>
                        &[
                                ("\"","\"", ),
                        ],
                
                
                Rakefile =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                
                Renpy =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                                ("`","`", ),
                        ],
                Ruby =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                RubyHtml =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Rust =>
                        &[
                                ("r#\"","\"#", ),
                                ("#\"","\"#", ),
                                ("\"","\"", ),
                        ],
                
                Sass =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Scala =>
                        &[
                                ("\"","\"", ),
                        ],
                
                Scons =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("'''","'''", ),
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Sh =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Sml =>
                        &[
                                ("\"","\"", ),
                        ],
                Solidity =>
                        &[
                                ("\"","\"", ),
                        ],
                
                
                Sql =>
                        &[
                                ("'","'", ),
                        ],
                Stratego =>
                        &[
                                ("\"","\"", ),
                                ("$[","]", ),
                                ("$<",">", ),
                                ("${","}", ),
                        ],
                Svelte =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                                ("`","`", ),
                        ],
                Svg =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Swift =>
                        &[
                                ("\"","\"", ),
                        ],
                Swig =>
                        &[
                                ("\"","\"", ),
                        ],
                SystemVerilog =>
                        &[
                                ("\"","\"", ),
                        ],
                Tcl =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                
                Thrift =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Toml =>
                        &[
                                ("\"\"\"","\"\"\"", ),
                                ("'''","'''", ),
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Tsx =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                                ("`","`", ),
                        ],
                Twig =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                TypeScript =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                                ("`","`", ),
                        ],
                
                
                
                UnrealScript =>
                        &[
                                ("\"","\"", ),
                        ],
                UnrealShader =>
                        &[
                                ("\"","\"", ),
                        ],
                UnrealShaderHeader =>
                        &[
                                ("\"","\"", ),
                        ],
                UrWeb =>
                        &[
                                ("\"","\"", ),
                        ],
                
                
                
                Vala =>
                        &[
                                ("\"","\"", ),
                        ],
                Velocity =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Verilog =>
                        &[
                                ("\"","\"", ),
                        ],
                
                
                VimScript =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                VisualBasic =>
                        &[
                                ("\"","\"", ),
                        ],
                VisualStudioProject =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                
                Vue =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                                ("`","`", ),
                        ],
                WebAssembly =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Wolfram =>
                        &[
                                ("\"","\"", ),
                        ],
                XSL =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Xaml =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                XcodeConfig =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Xml =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Xtend =>
                        &[
                                ("'''","'''", ),
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Yaml =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
                Zig =>
                        &[
                                ("\"","\"", ),
                                ("\\","
", ),
                        ],
                Zsh =>
                        &[
                                ("\"","\"", ),
                                ("'","'", ),
                        ],
            _ => &[],
        }
    }

    /// Returns the doc quotes of a language.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::Python;
    /// assert_eq!(lang.doc_quotes(), &[("\"\"\"", "\"\"\""), ("'''", "'''")]);
    /// ```
    pub fn doc_quotes(self) -> &'static [(&'static str, &'static str)] {
        match self {
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            Pony =>
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                        ],
            
            
            
            
            
            
            Python =>
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "'''",
                                    "'''",
                                ),
                        ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            _ => &[],
        }
    }

    /// Returns the shebang of a language.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::Bash;
    /// assert_eq!(lang.shebangs(), &["#!/bin/bash"]);
    /// ```
    pub fn shebangs(self) -> &'static [&'static str] {
        match self {
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            Bash =>
                    &[
                            "#!/bin/bash",
                    ],
            
            
            
            
            
            
            CShell =>
                    &[
                            "#!/bin/csh",
                    ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            Crystal =>
                    &[
                            "#!/usr/bin/crystal",
                    ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            Fish =>
                    &[
                            "#!/bin/fish",
                    ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            Perl =>
                    &[
                            "#!/usr/bin/perl",
                    ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            Sh =>
                    &[
                            "#!/bin/sh",
                    ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            Zsh =>
                    &[
                            "#!/bin/zsh",
                    ],
            _ => &[],
        }
    }

    pub(crate) fn start_any_comments(self) -> &'static [&'static str] {
        match self {
            Abap =>
                    &[
                        
                                "*",
                                "\"",
                        
                        
                    ],ActionScript =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Ada =>
                    &[
                        
                                "--",
                        
                        
                    ],Agda =>
                    &[
                        
                                "--",
                        
                                "{-",
                        
                    ],Alex =>
                    &[
                        
                        
                        
                    ],Arduino =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Asn1 =>
                    &[
                        
                                "--",
                        
                                "/*",
                        
                    ],Asp =>
                    &[
                        
                                "'",
                                "REM",
                        
                        
                    ],AspNet =>
                    &[
                        
                        
                                "<!--",
                                "<%--",
                        
                    ],Assembly =>
                    &[
                        
                                ";",
                        
                        
                    ],AssemblyGAS =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],AutoHotKey =>
                    &[
                        
                                ";",
                        
                                "/*",
                        
                    ],Autoconf =>
                    &[
                        
                                "#",
                                "dnl",
                        
                        
                    ],Automake =>
                    &[
                        
                                "#",
                        
                        
                    ],Bash =>
                    &[
                        
                                "#",
                        
                        
                    ],Batch =>
                    &[
                        
                                "REM",
                                "::",
                        
                        
                    ],BrightScript =>
                    &[
                        
                                "'",
                                "REM",
                        
                        
                    ],C =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],CHeader =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],CMake =>
                    &[
                        
                                "#",
                        
                        
                    ],CSharp =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],CShell =>
                    &[
                        
                                "#",
                        
                        
                    ],Cabal =>
                    &[
                        
                                "--",
                        
                                "{-",
                        
                    ],Cassius =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Ceylon =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Clojure =>
                    &[
                        
                                ";",
                        
                        
                    ],ClojureC =>
                    &[
                        
                                ";",
                        
                        
                    ],ClojureScript =>
                    &[
                        
                                ";",
                        
                        
                    ],Cobol =>
                    &[
                        
                                "*",
                        
                        
                    ],CoffeeScript =>
                    &[
                        
                                "#",
                        
                                "###",
                        
                    ],Cogent =>
                    &[
                        
                                "--",
                        
                        
                    ],ColdFusion =>
                    &[
                        
                        
                                "<!---",
                        
                    ],ColdFusionScript =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Coq =>
                    &[
                        
                        
                                "(*",
                        
                    ],Cpp =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],CppHeader =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Crystal =>
                    &[
                        
                                "#",
                        
                        
                    ],Css =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],D =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                                "/+",
                    ],Dart =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],DeviceTree =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Dhall =>
                    &[
                        
                                "--",
                        
                                "{-",
                        
                    ],Dockerfile =>
                    &[
                        
                                "#",
                        
                        
                    ],DotNetResource =>
                    &[
                        
                        
                                "<!--",
                        
                    ],DreamMaker =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Dust =>
                    &[
                        
                        
                                "{!",
                        
                    ],Edn =>
                    &[
                        
                                ";",
                        
                        
                    ],Elisp =>
                    &[
                        
                                ";",
                        
                        
                    ],Elixir =>
                    &[
                        
                                "#",
                        
                        
                    ],Elm =>
                    &[
                        
                                "--",
                        
                                "{-",
                        
                    ],Elvish =>
                    &[
                        
                                "#",
                        
                        
                    ],EmacsDevEnv =>
                    &[
                        
                                ";",
                        
                        
                    ],Emojicode =>
                    &[
                        
                                "💭",
                        
                                "💭🔜",
                                "📗",
                                "📘",
                        
                    ],Erlang =>
                    &[
                        
                                "%",
                        
                        
                    ],FEN =>
                    &[
                        
                        
                        
                    ],FSharp =>
                    &[
                        
                                "//",
                        
                                "(*",
                        
                    ],Fish =>
                    &[
                        
                                "#",
                        
                        
                    ],FlatBuffers =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Forth =>
                    &[
                        
                                "\\",
                        
                                "( ",
                        
                    ],FortranLegacy =>
                    &[
                        
                                "c",
                                "C",
                                "!",
                                "*",
                        
                        
                    ],FortranModern =>
                    &[
                        
                                "!",
                        
                        
                    ],FreeMarker =>
                    &[
                        
                        
                                "<#--",
                        
                    ],Fstar =>
                    &[
                        
                        
                                "(*",
                        
                    ],Futhark =>
                    &[
                        
                                "--",
                        
                        
                    ],GDB =>
                    &[
                        
                                "#",
                        
                        
                    ],GdScript =>
                    &[
                        
                                "#",
                        
                        
                    ],Gherkin =>
                    &[
                        
                                "#",
                        
                        
                    ],Glsl =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Go =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Gohtml =>
                    &[
                        
                        
                                "<!--",
                                "{{/*",
                        
                    ],Graphql =>
                    &[
                        
                                "#",
                        
                        
                    ],Groovy =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Hamlet =>
                    &[
                        
                        
                                "<!--",
                        
                    ],Handlebars =>
                    &[
                        
                        
                                "<!--",
                                "{{!",
                        
                    ],Happy =>
                    &[
                        
                        
                        
                    ],Haskell =>
                    &[
                        
                                "--",
                        
                                "{-",
                        
                    ],Haxe =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Hcl =>
                    &[
                        
                                "#",
                                "//",
                        
                                "/*",
                        
                    ],Headache =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Hex =>
                    &[
                        
                        
                        
                    ],Hlsl =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],HolyC =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Html =>
                    &[
                        
                                "//",
                        
                                "<!--",
                                "/*",
                        
                    ],Idris =>
                    &[
                        
                                "--",
                        
                                "{-",
                        
                    ],Ini =>
                    &[
                        
                                ";",
                                "#",
                        
                        
                    ],IntelHex =>
                    &[
                        
                        
                        
                    ],Isabelle =>
                    &[
                        
                                "--",
                        
                                "{*",
                                "(*",
                                "‹",
                                "\\<open>",
                        
                    ],Jai =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Java =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],JavaScript =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Json =>
                    &[
                        
                        
                        
                    ],Jsx =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Julia =>
                    &[
                        
                                "#",
                        
                                "#=",
                        
                    ],Julius =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],KakouneScript =>
                    &[
                        
                                "#",
                        
                        
                    ],Kotlin =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],LLVM =>
                    &[
                        
                                ";",
                        
                        
                    ],Lean =>
                    &[
                        
                                "--",
                        
                                "/-",
                        
                    ],Less =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],LinkerScript =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Liquid =>
                    &[
                        
                        
                                "{% comment %}",
                        
                    ],Lisp =>
                    &[
                        
                                ";",
                        
                                "#|",
                        
                    ],Logtalk =>
                    &[
                        
                                "%",
                        
                                "/*",
                        
                    ],Lua =>
                    &[
                        
                                "--",
                        
                                "--[[",
                        
                    ],Lucius =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Madlang =>
                    &[
                        
                                "#",
                        
                                "{#",
                        
                    ],Makefile =>
                    &[
                        
                                "#",
                        
                        
                    ],Markdown =>
                    &[
                        
                        
                        
                    ],Meson =>
                    &[
                        
                                "#",
                        
                        
                    ],Mint =>
                    &[
                        
                        
                        
                    ],ModuleDef =>
                    &[
                        
                                ";",
                        
                        
                    ],MoonScript =>
                    &[
                        
                                "--",
                        
                        
                    ],MsBuild =>
                    &[
                        
                        
                                "<!--",
                        
                    ],Mustache =>
                    &[
                        
                        
                                "{{!",
                        
                    ],Nim =>
                    &[
                        
                                "#",
                        
                        
                    ],Nix =>
                    &[
                        
                                "#",
                        
                                "/*",
                        
                    ],NotQuitePerl =>
                    &[
                        
                                "#",
                        
                                "=begin",
                        
                    ],OCaml =>
                    &[
                        
                        
                                "(*",
                        
                    ],ObjectiveC =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],ObjectiveCpp =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Odin =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],OpenType =>
                    &[
                        
                                "#",
                        
                        
                    ],Org =>
                    &[
                        
                                "# ",
                        
                        
                    ],Oz =>
                    &[
                        
                                "%",
                        
                                "/*",
                        
                    ],PSL =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Pan =>
                    &[
                        
                                "#",
                        
                        
                    ],Pascal =>
                    &[
                        
                                "//",
                        
                                "{",
                                "(*",
                        
                    ],Perl =>
                    &[
                        
                                "#",
                        
                                "=pod",
                        
                    ],Perl6 =>
                    &[
                        
                                "#",
                        
                                "=begin",
                        
                    ],Pest =>
                    &[
                        
                                "//",
                        
                        
                    ],Php =>
                    &[
                        
                                "#",
                                "//",
                        
                                "/*",
                        
                    ],Polly =>
                    &[
                        
                        
                                "<!--",
                        
                    ],Pony =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],PostCss =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],PowerShell =>
                    &[
                        
                                "#",
                        
                                "<#",
                        
                    ],Processing =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Prolog =>
                    &[
                        
                                "%",
                        
                                "/*",
                        
                    ],Protobuf =>
                    &[
                        
                                "//",
                        
                        
                    ],PureScript =>
                    &[
                        
                                "--",
                        
                                "{-",
                        
                    ],Python =>
                    &[
                        
                                "#",
                        
                        
                    ],Qcl =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Qml =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],R =>
                    &[
                        
                                "#",
                        
                        
                    ],RON =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],RPMSpecfile =>
                    &[
                        
                                "#",
                        
                        
                    ],Racket =>
                    &[
                        
                                ";",
                        
                                "#|",
                        
                    ],Rakefile =>
                    &[
                        
                                "#",
                        
                                "=begin",
                        
                    ],Razor =>
                    &[
                        
                        
                                "<!--",
                                "@*",
                        
                    ],ReStructuredText =>
                    &[
                        
                        
                        
                    ],Renpy =>
                    &[
                        
                                "#",
                        
                        
                    ],Ruby =>
                    &[
                        
                                "#",
                        
                                "=begin",
                        
                    ],RubyHtml =>
                    &[
                        
                        
                                "<!--",
                        
                    ],Rust =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],SRecode =>
                    &[
                        
                                ";;",
                        
                        
                    ],Sass =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Scala =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Scheme =>
                    &[
                        
                                ";",
                        
                                "#|",
                        
                    ],Scons =>
                    &[
                        
                                "#",
                        
                        
                    ],Sh =>
                    &[
                        
                                "#",
                        
                        
                    ],Sml =>
                    &[
                        
                        
                                "(*",
                        
                    ],Solidity =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],SpecmanE =>
                    &[
                        
                                "--",
                                "//",
                        
                                "'>",
                        
                    ],Spice =>
                    &[
                        
                                "*",
                        
                        
                    ],Sql =>
                    &[
                        
                                "--",
                        
                                "/*",
                        
                    ],Stratego =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Svelte =>
                    &[
                        
                                "//",
                        
                                "/*",
                                "<!--",
                        
                    ],Svg =>
                    &[
                        
                        
                                "<!--",
                        
                    ],Swift =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Swig =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],SystemVerilog =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Tcl =>
                    &[
                        
                                "#",
                        
                        
                    ],Tex =>
                    &[
                        
                                "%",
                        
                        
                    ],Text =>
                    &[
                        
                        
                        
                    ],Thrift =>
                    &[
                        
                                "#",
                                "//",
                        
                                "/*",
                        
                    ],Toml =>
                    &[
                        
                                "#",
                        
                        
                    ],Tsx =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Twig =>
                    &[
                        
                        
                                "{#",
                        
                    ],TypeScript =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],UnrealDeveloperMarkdown =>
                    &[
                        
                        
                        
                    ],UnrealPlugin =>
                    &[
                        
                        
                        
                    ],UnrealProject =>
                    &[
                        
                        
                        
                    ],UnrealScript =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],UnrealShader =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],UnrealShaderHeader =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],UrWeb =>
                    &[
                        
                        
                                "(*",
                        
                    ],UrWebProject =>
                    &[
                        
                                "#",
                        
                        
                    ],VB6 =>
                    &[
                        
                                "'",
                        
                        
                    ],VBScript =>
                    &[
                        
                                "'",
                                "REM",
                        
                        
                    ],Vala =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Velocity =>
                    &[
                        
                                "##",
                        
                                "#*",
                        
                    ],Verilog =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],VerilogArgsFile =>
                    &[
                        
                        
                        
                    ],Vhdl =>
                    &[
                        
                                "--",
                        
                        
                    ],VimScript =>
                    &[
                        
                                "\"",
                        
                        
                    ],VisualBasic =>
                    &[
                        
                                "'",
                        
                        
                    ],VisualStudioProject =>
                    &[
                        
                        
                                "<!--",
                        
                    ],VisualStudioSolution =>
                    &[
                        
                        
                        
                    ],Vue =>
                    &[
                        
                                "//",
                        
                                "<!--",
                                "/*",
                        
                    ],WebAssembly =>
                    &[
                        
                                ";;",
                        
                        
                    ],Wolfram =>
                    &[
                        
                        
                                "(*",
                        
                    ],XSL =>
                    &[
                        
                        
                                "<!--",
                        
                    ],Xaml =>
                    &[
                        
                        
                                "<!--",
                        
                    ],XcodeConfig =>
                    &[
                        
                                "//",
                        
                        
                    ],Xml =>
                    &[
                        
                        
                                "<!--",
                        
                    ],Xtend =>
                    &[
                        
                                "//",
                        
                                "/*",
                        
                    ],Yaml =>
                    &[
                        
                                "#",
                        
                        
                    ],Zig =>
                    &[
                        
                                "//",
                        
                        
                    ],Zsh =>
                    &[
                        
                                "#",
                        
                        
                    ],
        }
    }


    pub(crate) fn _start_string_literals(self) -> &'static [&'static str] {
        match self {
            
            
            ActionScript =>
                    &[
                            "\"",
                    ],
            
            
            
            Arduino =>
                    &[
                            "\"",
                    ],
            Asn1 =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            Assembly =>
                    &[
                            "\"",
                            "'",
                    ],
            AssemblyGAS =>
                    &[
                            "\"",
                    ],
            
            
            
            Bash =>
                    &[
                            "\"",
                            "'",
                    ],
            
            BrightScript =>
                    &[
                            "\"",
                    ],
            C =>
                    &[
                            "\"",
                    ],
            CHeader =>
                    &[
                            "\"",
                    ],
            CMake =>
                    &[
                            "\"",
                    ],
            CSharp =>
                    &[
                            "\"",
                    ],
            
            
            Cassius =>
                    &[
                            "\"",
                            "'",
                    ],
            Ceylon =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            Clojure =>
                    &[
                            "\"",
                    ],
            ClojureC =>
                    &[
                            "\"",
                    ],
            ClojureScript =>
                    &[
                            "\"",
                    ],
            
            CoffeeScript =>
                    &[
                            "\"",
                            "'",
                    ],
            
            ColdFusion =>
                    &[
                            "\"",
                            "'",
                    ],
            ColdFusionScript =>
                    &[
                            "\"",
                    ],
            Coq =>
                    &[
                            "\"",
                    ],
            Cpp =>
                    &[
                            "\"",
                    ],
            CppHeader =>
                    &[
                            "\"",
                    ],
            Crystal =>
                    &[
                            "\"",
                            "'",
                    ],
            Css =>
                    &[
                            "\"",
                            "'",
                    ],
            D =>
                    &[
                            "\"",
                            "'",
                    ],
            Dart =>
                    &[
                            "\"\"\"",
                            "'''",
                            "\"",
                            "'",
                    ],
            DeviceTree =>
                    &[
                            "\"",
                    ],
            Dhall =>
                    &[
                            "\"",
                            "''",
                    ],
            Dockerfile =>
                    &[
                            "\"",
                            "'",
                    ],
            DotNetResource =>
                    &[
                            "\"",
                    ],
            DreamMaker =>
                    &[
                            "{\"",
                            "'",
                    ],
            
            
            
            Elixir =>
                    &[
                            "\"\"\"",
                            "'''",
                            "\"",
                            "'",
                    ],
            
            Elvish =>
                    &[
                            "\"",
                            "'",
                    ],
            
            Emojicode =>
                    &[
                            "❌🔤",
                    ],
            
            
            FSharp =>
                    &[
                            "\"",
                    ],
            Fish =>
                    &[
                            "\"",
                            "'",
                    ],
            FlatBuffers =>
                    &[
                            "\"",
                    ],
            
            FortranLegacy =>
                    &[
                            "\"",
                            "'",
                    ],
            FortranModern =>
                    &[
                            "\"",
                    ],
            
            Fstar =>
                    &[
                            "\"",
                    ],
            
            
            GdScript =>
                    &[
                            "\"\"\"",
                            "\"",
                            "'",
                    ],
            
            Glsl =>
                    &[
                            "\"",
                    ],
            Go =>
                    &[
                            "\"",
                    ],
            Gohtml =>
                    &[
                            "\"",
                            "'",
                    ],
            Graphql =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            Groovy =>
                    &[
                            "\"",
                    ],
            Hamlet =>
                    &[
                            "\"",
                            "'",
                    ],
            Handlebars =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            Haxe =>
                    &[
                            "\"",
                            "'",
                    ],
            Hcl =>
                    &[
                            "\"",
                    ],
            Headache =>
                    &[
                            "\"",
                    ],
            
            Hlsl =>
                    &[
                            "\"",
                    ],
            HolyC =>
                    &[
                            "\"",
                    ],
            Html =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            Idris =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            
            
            Isabelle =>
                    &[
                            "''",
                    ],
            Jai =>
                    &[
                            "\"",
                    ],
            Java =>
                    &[
                            "\"",
                    ],
            JavaScript =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            
            Jsx =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            Julia =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            Julius =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            KakouneScript =>
                    &[
                            "\"",
                            "'",
                    ],
            Kotlin =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            LLVM =>
                    &[
                            "\"",
                            "'",
                    ],
            
            Less =>
                    &[
                            "\"",
                            "'",
                    ],
            LinkerScript =>
                    &[
                            "\"",
                    ],
            Liquid =>
                    &[
                            "\"",
                            "'",
                    ],
            
            Logtalk =>
                    &[
                            "\"",
                    ],
            Lua =>
                    &[
                            "\"",
                            "'",
                    ],
            Lucius =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            
            Meson =>
                    &[
                            "'''",
                            "'",
                    ],
            
            
            MoonScript =>
                    &[
                            "\"",
                            "'",
                    ],
            MsBuild =>
                    &[
                            "\"",
                            "'",
                    ],
            Mustache =>
                    &[
                            "\"",
                            "'",
                    ],
            Nim =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            Nix =>
                    &[
                            "\"",
                    ],
            NotQuitePerl =>
                    &[
                            "\"",
                            "'",
                    ],
            OCaml =>
                    &[
                            "\"",
                    ],
            ObjectiveC =>
                    &[
                            "\"",
                    ],
            ObjectiveCpp =>
                    &[
                            "\"",
                    ],
            Odin =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            Oz =>
                    &[
                            "\"",
                    ],
            PSL =>
                    &[
                            "\"",
                    ],
            Pan =>
                    &[
                            "\"",
                            "'",
                    ],
            Pascal =>
                    &[
                            "'",
                    ],
            Perl =>
                    &[
                            "\"",
                            "'",
                    ],
            Perl6 =>
                    &[
                            "\"",
                            "'",
                    ],
            Pest =>
                    &[
                            "\"",
                            "'",
                    ],
            Php =>
                    &[
                            "\"",
                            "'",
                    ],
            Polly =>
                    &[
                            "\"",
                            "'",
                    ],
            Pony =>
                    &[
                            "\"",
                    ],
            PostCss =>
                    &[
                            "\"",
                            "'",
                    ],
            PowerShell =>
                    &[
                            "\"@",
                            "\"",
                            "@'",
                            "'",
                    ],
            Processing =>
                    &[
                            "\"",
                    ],
            Prolog =>
                    &[
                            "\"",
                    ],
            
            
            Python =>
                    &[
                            "\"",
                            "'",
                    ],
            Qcl =>
                    &[
                            "\"",
                    ],
            Qml =>
                    &[
                            "\"",
                            "'",
                    ],
            
            RON =>
                    &[
                            "\"",
                    ],
            
            
            Rakefile =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            Renpy =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            Ruby =>
                    &[
                            "\"",
                            "'",
                    ],
            RubyHtml =>
                    &[
                            "\"",
                            "'",
                    ],
            Rust =>
                    &[
                            "r#\"",
                            "#\"",
                            "\"",
                    ],
            
            Sass =>
                    &[
                            "\"",
                            "'",
                    ],
            Scala =>
                    &[
                            "\"",
                    ],
            
            Scons =>
                    &[
                            "\"\"\"",
                            "'''",
                            "\"",
                            "'",
                    ],
            Sh =>
                    &[
                            "\"",
                            "'",
                    ],
            Sml =>
                    &[
                            "\"",
                    ],
            Solidity =>
                    &[
                            "\"",
                    ],
            
            
            Sql =>
                    &[
                            "'",
                    ],
            Stratego =>
                    &[
                            "\"",
                            "$[",
                            "$<",
                            "${",
                    ],
            Svelte =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            Svg =>
                    &[
                            "\"",
                            "'",
                    ],
            Swift =>
                    &[
                            "\"",
                    ],
            Swig =>
                    &[
                            "\"",
                    ],
            SystemVerilog =>
                    &[
                            "\"",
                    ],
            Tcl =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            Thrift =>
                    &[
                            "\"",
                            "'",
                    ],
            Toml =>
                    &[
                            "\"\"\"",
                            "'''",
                            "\"",
                            "'",
                    ],
            Tsx =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            Twig =>
                    &[
                            "\"",
                            "'",
                    ],
            TypeScript =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            
            
            
            UnrealScript =>
                    &[
                            "\"",
                    ],
            UnrealShader =>
                    &[
                            "\"",
                    ],
            UnrealShaderHeader =>
                    &[
                            "\"",
                    ],
            UrWeb =>
                    &[
                            "\"",
                    ],
            
            
            
            Vala =>
                    &[
                            "\"",
                    ],
            Velocity =>
                    &[
                            "\"",
                            "'",
                    ],
            Verilog =>
                    &[
                            "\"",
                    ],
            
            
            VimScript =>
                    &[
                            "\"",
                            "'",
                    ],
            VisualBasic =>
                    &[
                            "\"",
                    ],
            VisualStudioProject =>
                    &[
                            "\"",
                            "'",
                    ],
            
            Vue =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            WebAssembly =>
                    &[
                            "\"",
                            "'",
                    ],
            Wolfram =>
                    &[
                            "\"",
                    ],
            XSL =>
                    &[
                            "\"",
                            "'",
                    ],
            Xaml =>
                    &[
                            "\"",
                            "'",
                    ],
            XcodeConfig =>
                    &[
                            "\"",
                            "'",
                    ],
            Xml =>
                    &[
                            "\"",
                            "'",
                    ],
            Xtend =>
                    &[
                            "'''",
                            "\"",
                            "'",
                    ],
            Yaml =>
                    &[
                            "\"",
                            "'",
                    ],
            Zig =>
                    &[
                            "\"",
                            "\\",
                    ],
            Zsh =>
                    &[
                            "\"",
                            "'",
                    ],
            _ => &[],
        }
    }

    pub(crate) fn _end_string_literals(self) -> &'static [&'static str] {
        match self {
            
            
            ActionScript =>
                    &[
                            "\"",
                    ],
            
            
            
            Arduino =>
                    &[
                            "\"",
                    ],
            Asn1 =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            Assembly =>
                    &[
                            "\"",
                            "'",
                    ],
            AssemblyGAS =>
                    &[
                            "\"",
                    ],
            
            
            
            Bash =>
                    &[
                            "\"",
                            "'",
                    ],
            
            BrightScript =>
                    &[
                            "\"",
                    ],
            C =>
                    &[
                            "\"",
                    ],
            CHeader =>
                    &[
                            "\"",
                    ],
            CMake =>
                    &[
                            "\"",
                    ],
            CSharp =>
                    &[
                            "\"",
                    ],
            
            
            Cassius =>
                    &[
                            "\"",
                            "'",
                    ],
            Ceylon =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            Clojure =>
                    &[
                            "\"",
                    ],
            ClojureC =>
                    &[
                            "\"",
                    ],
            ClojureScript =>
                    &[
                            "\"",
                    ],
            
            CoffeeScript =>
                    &[
                            "\"",
                            "'",
                    ],
            
            ColdFusion =>
                    &[
                            "\"",
                            "'",
                    ],
            ColdFusionScript =>
                    &[
                            "\"",
                    ],
            Coq =>
                    &[
                            "\"",
                    ],
            Cpp =>
                    &[
                            "\"",
                    ],
            CppHeader =>
                    &[
                            "\"",
                    ],
            Crystal =>
                    &[
                            "\"",
                            "'",
                    ],
            Css =>
                    &[
                            "\"",
                            "'",
                    ],
            D =>
                    &[
                            "\"",
                            "'",
                    ],
            Dart =>
                    &[
                            "\"\"\"",
                            "'''",
                            "\"",
                            "'",
                    ],
            DeviceTree =>
                    &[
                            "\"",
                    ],
            Dhall =>
                    &[
                            "\"",
                            "''",
                    ],
            Dockerfile =>
                    &[
                            "\"",
                            "'",
                    ],
            DotNetResource =>
                    &[
                            "\"",
                    ],
            DreamMaker =>
                    &[
                            "\"}",
                            "'",
                    ],
            
            
            
            Elixir =>
                    &[
                            "\"\"\"",
                            "'''",
                            "\"",
                            "'",
                    ],
            
            Elvish =>
                    &[
                            "\"",
                            "'",
                    ],
            
            Emojicode =>
                    &[
                            "❌🔤",
                    ],
            
            
            FSharp =>
                    &[
                            "\"",
                    ],
            Fish =>
                    &[
                            "\"",
                            "'",
                    ],
            FlatBuffers =>
                    &[
                            "\"",
                    ],
            
            FortranLegacy =>
                    &[
                            "\"",
                            "'",
                    ],
            FortranModern =>
                    &[
                            "\"",
                    ],
            
            Fstar =>
                    &[
                            "\"",
                    ],
            
            
            GdScript =>
                    &[
                            "\"\"\"",
                            "\"",
                            "'",
                    ],
            
            Glsl =>
                    &[
                            "\"",
                    ],
            Go =>
                    &[
                            "\"",
                    ],
            Gohtml =>
                    &[
                            "\"",
                            "'",
                    ],
            Graphql =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            Groovy =>
                    &[
                            "\"",
                    ],
            Hamlet =>
                    &[
                            "\"",
                            "'",
                    ],
            Handlebars =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            Haxe =>
                    &[
                            "\"",
                            "'",
                    ],
            Hcl =>
                    &[
                            "\"",
                    ],
            Headache =>
                    &[
                            "\"",
                    ],
            
            Hlsl =>
                    &[
                            "\"",
                    ],
            HolyC =>
                    &[
                            "\"",
                    ],
            Html =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            Idris =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            
            
            Isabelle =>
                    &[
                            "''",
                    ],
            Jai =>
                    &[
                            "\"",
                    ],
            Java =>
                    &[
                            "\"",
                    ],
            JavaScript =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            
            Jsx =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            Julia =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            Julius =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            KakouneScript =>
                    &[
                            "\"",
                            "'",
                    ],
            Kotlin =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            LLVM =>
                    &[
                            "\"",
                            "'",
                    ],
            
            Less =>
                    &[
                            "\"",
                            "'",
                    ],
            LinkerScript =>
                    &[
                            "\"",
                    ],
            Liquid =>
                    &[
                            "\"",
                            "'",
                    ],
            
            Logtalk =>
                    &[
                            "\"",
                    ],
            Lua =>
                    &[
                            "\"",
                            "'",
                    ],
            Lucius =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            
            Meson =>
                    &[
                            "'''",
                            "'",
                    ],
            
            
            MoonScript =>
                    &[
                            "\"",
                            "'",
                    ],
            MsBuild =>
                    &[
                            "\"",
                            "'",
                    ],
            Mustache =>
                    &[
                            "\"",
                            "'",
                    ],
            Nim =>
                    &[
                            "\"\"\"",
                            "\"",
                    ],
            Nix =>
                    &[
                            "\"",
                    ],
            NotQuitePerl =>
                    &[
                            "\"",
                            "'",
                    ],
            OCaml =>
                    &[
                            "\"",
                    ],
            ObjectiveC =>
                    &[
                            "\"",
                    ],
            ObjectiveCpp =>
                    &[
                            "\"",
                    ],
            Odin =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            Oz =>
                    &[
                            "\"",
                    ],
            PSL =>
                    &[
                            "\"",
                    ],
            Pan =>
                    &[
                            "\"",
                            "'",
                    ],
            Pascal =>
                    &[
                            "'",
                    ],
            Perl =>
                    &[
                            "\"",
                            "'",
                    ],
            Perl6 =>
                    &[
                            "\"",
                            "'",
                    ],
            Pest =>
                    &[
                            "\"",
                            "'",
                    ],
            Php =>
                    &[
                            "\"",
                            "'",
                    ],
            Polly =>
                    &[
                            "\"",
                            "'",
                    ],
            Pony =>
                    &[
                            "\"",
                    ],
            PostCss =>
                    &[
                            "\"",
                            "'",
                    ],
            PowerShell =>
                    &[
                            "@\"",
                            "\"",
                            "'@",
                            "'",
                    ],
            Processing =>
                    &[
                            "\"",
                    ],
            Prolog =>
                    &[
                            "\"",
                    ],
            
            
            Python =>
                    &[
                            "\"",
                            "'",
                    ],
            Qcl =>
                    &[
                            "\"",
                    ],
            Qml =>
                    &[
                            "\"",
                            "'",
                    ],
            
            RON =>
                    &[
                            "\"",
                    ],
            
            
            Rakefile =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            Renpy =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            Ruby =>
                    &[
                            "\"",
                            "'",
                    ],
            RubyHtml =>
                    &[
                            "\"",
                            "'",
                    ],
            Rust =>
                    &[
                            "\"#",
                            "\"#",
                            "\"",
                    ],
            
            Sass =>
                    &[
                            "\"",
                            "'",
                    ],
            Scala =>
                    &[
                            "\"",
                    ],
            
            Scons =>
                    &[
                            "\"\"\"",
                            "'''",
                            "\"",
                            "'",
                    ],
            Sh =>
                    &[
                            "\"",
                            "'",
                    ],
            Sml =>
                    &[
                            "\"",
                    ],
            Solidity =>
                    &[
                            "\"",
                    ],
            
            
            Sql =>
                    &[
                            "'",
                    ],
            Stratego =>
                    &[
                            "\"",
                            "]",
                            ">",
                            "}",
                    ],
            Svelte =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            Svg =>
                    &[
                            "\"",
                            "'",
                    ],
            Swift =>
                    &[
                            "\"",
                    ],
            Swig =>
                    &[
                            "\"",
                    ],
            SystemVerilog =>
                    &[
                            "\"",
                    ],
            Tcl =>
                    &[
                            "\"",
                            "'",
                    ],
            
            
            Thrift =>
                    &[
                            "\"",
                            "'",
                    ],
            Toml =>
                    &[
                            "\"\"\"",
                            "'''",
                            "\"",
                            "'",
                    ],
            Tsx =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            Twig =>
                    &[
                            "\"",
                            "'",
                    ],
            TypeScript =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            
            
            
            UnrealScript =>
                    &[
                            "\"",
                    ],
            UnrealShader =>
                    &[
                            "\"",
                    ],
            UnrealShaderHeader =>
                    &[
                            "\"",
                    ],
            UrWeb =>
                    &[
                            "\"",
                    ],
            
            
            
            Vala =>
                    &[
                            "\"",
                    ],
            Velocity =>
                    &[
                            "\"",
                            "'",
                    ],
            Verilog =>
                    &[
                            "\"",
                    ],
            
            
            VimScript =>
                    &[
                            "\"",
                            "'",
                    ],
            VisualBasic =>
                    &[
                            "\"",
                    ],
            VisualStudioProject =>
                    &[
                            "\"",
                            "'",
                    ],
            
            Vue =>
                    &[
                            "\"",
                            "'",
                            "`",
                    ],
            WebAssembly =>
                    &[
                            "\"",
                            "'",
                    ],
            Wolfram =>
                    &[
                            "\"",
                    ],
            XSL =>
                    &[
                            "\"",
                            "'",
                    ],
            Xaml =>
                    &[
                            "\"",
                            "'",
                    ],
            XcodeConfig =>
                    &[
                            "\"",
                            "'",
                    ],
            Xml =>
                    &[
                            "\"",
                            "'",
                    ],
            Xtend =>
                    &[
                            "'''",
                            "\"",
                            "'",
                    ],
            Yaml =>
                    &[
                            "\"",
                            "'",
                    ],
            Zig =>
                    &[
                            "\"",
                            "
",
                    ],
            Zsh =>
                    &[
                            "\"",
                            "'",
                    ],
            _ => &[],
        }
    }

    pub(crate) fn _start_multi_line_comments(self) -> &'static [&'static str] {
        match self {
            
            
            ActionScript =>
                    &[
                            "/*",
                    ],
            
            Agda =>
                    &[
                            "{-",
                    ],
            
            Arduino =>
                    &[
                            "/*",
                    ],
            Asn1 =>
                    &[
                            "/*",
                    ],
            
            AspNet =>
                    &[
                            "<!--",
                            "<%--",
                    ],
            
            AssemblyGAS =>
                    &[
                            "/*",
                    ],
            AutoHotKey =>
                    &[
                            "/*",
                    ],
            
            
            
            
            
            C =>
                    &[
                            "/*",
                    ],
            CHeader =>
                    &[
                            "/*",
                    ],
            
            CSharp =>
                    &[
                            "/*",
                    ],
            
            Cabal =>
                    &[
                            "{-",
                    ],
            Cassius =>
                    &[
                            "/*",
                    ],
            Ceylon =>
                    &[
                            "/*",
                    ],
            
            
            
            
            CoffeeScript =>
                    &[
                            "###",
                    ],
            
            ColdFusion =>
                    &[
                            "<!---",
                    ],
            ColdFusionScript =>
                    &[
                            "/*",
                    ],
            Coq =>
                    &[
                            "(*",
                    ],
            Cpp =>
                    &[
                            "/*",
                    ],
            CppHeader =>
                    &[
                            "/*",
                    ],
            
            Css =>
                    &[
                            "/*",
                    ],
            D =>
                    &[
                            "/*",
                    ],
            Dart =>
                    &[
                            "/*",
                    ],
            DeviceTree =>
                    &[
                            "/*",
                    ],
            Dhall =>
                    &[
                            "{-",
                    ],
            
            DotNetResource =>
                    &[
                            "<!--",
                    ],
            DreamMaker =>
                    &[
                            "/*",
                    ],
            Dust =>
                    &[
                            "{!",
                    ],
            
            
            
            Elm =>
                    &[
                            "{-",
                    ],
            
            
            Emojicode =>
                    &[
                            "💭🔜",
                            "📗",
                            "📘",
                    ],
            
            
            FSharp =>
                    &[
                            "(*",
                    ],
            
            FlatBuffers =>
                    &[
                            "/*",
                    ],
            Forth =>
                    &[
                            "( ",
                    ],
            
            
            FreeMarker =>
                    &[
                            "<#--",
                    ],
            Fstar =>
                    &[
                            "(*",
                    ],
            
            
            
            
            Glsl =>
                    &[
                            "/*",
                    ],
            Go =>
                    &[
                            "/*",
                    ],
            Gohtml =>
                    &[
                            "<!--",
                            "{{/*",
                    ],
            
            Groovy =>
                    &[
                            "/*",
                    ],
            Hamlet =>
                    &[
                            "<!--",
                    ],
            Handlebars =>
                    &[
                            "<!--",
                            "{{!",
                    ],
            
            Haskell =>
                    &[
                            "{-",
                    ],
            Haxe =>
                    &[
                            "/*",
                    ],
            Hcl =>
                    &[
                            "/*",
                    ],
            Headache =>
                    &[
                            "/*",
                    ],
            
            Hlsl =>
                    &[
                            "/*",
                    ],
            HolyC =>
                    &[
                            "/*",
                    ],
            Html =>
                    &[
                            "<!--",
                            "/*",
                    ],
            Idris =>
                    &[
                            "{-",
                    ],
            
            
            Isabelle =>
                    &[
                            "{*",
                            "(*",
                            "‹",
                            "\\<open>",
                    ],
            Jai =>
                    &[
                            "/*",
                    ],
            Java =>
                    &[
                            "/*",
                    ],
            JavaScript =>
                    &[
                            "/*",
                    ],
            
            Jsx =>
                    &[
                            "/*",
                    ],
            Julia =>
                    &[
                            "#=",
                    ],
            Julius =>
                    &[
                            "/*",
                    ],
            
            Kotlin =>
                    &[
                            "/*",
                    ],
            
            Lean =>
                    &[
                            "/-",
                    ],
            Less =>
                    &[
                            "/*",
                    ],
            LinkerScript =>
                    &[
                            "/*",
                    ],
            Liquid =>
                    &[
                            "{% comment %}",
                    ],
            Lisp =>
                    &[
                            "#|",
                    ],
            Logtalk =>
                    &[
                            "/*",
                    ],
            Lua =>
                    &[
                            "--[[",
                    ],
            Lucius =>
                    &[
                            "/*",
                    ],
            Madlang =>
                    &[
                            "{#",
                    ],
            
            
            
            
            
            
            MsBuild =>
                    &[
                            "<!--",
                    ],
            Mustache =>
                    &[
                            "{{!",
                    ],
            
            Nix =>
                    &[
                            "/*",
                    ],
            NotQuitePerl =>
                    &[
                            "=begin",
                    ],
            OCaml =>
                    &[
                            "(*",
                    ],
            ObjectiveC =>
                    &[
                            "/*",
                    ],
            ObjectiveCpp =>
                    &[
                            "/*",
                    ],
            Odin =>
                    &[
                            "/*",
                    ],
            
            
            Oz =>
                    &[
                            "/*",
                    ],
            PSL =>
                    &[
                            "/*",
                    ],
            
            Pascal =>
                    &[
                            "{",
                            "(*",
                    ],
            Perl =>
                    &[
                            "=pod",
                    ],
            Perl6 =>
                    &[
                            "=begin",
                    ],
            
            Php =>
                    &[
                            "/*",
                    ],
            Polly =>
                    &[
                            "<!--",
                    ],
            Pony =>
                    &[
                            "/*",
                    ],
            PostCss =>
                    &[
                            "/*",
                    ],
            PowerShell =>
                    &[
                            "<#",
                    ],
            Processing =>
                    &[
                            "/*",
                    ],
            Prolog =>
                    &[
                            "/*",
                    ],
            
            PureScript =>
                    &[
                            "{-",
                    ],
            
            Qcl =>
                    &[
                            "/*",
                    ],
            Qml =>
                    &[
                            "/*",
                    ],
            
            RON =>
                    &[
                            "/*",
                    ],
            
            Racket =>
                    &[
                            "#|",
                    ],
            Rakefile =>
                    &[
                            "=begin",
                    ],
            Razor =>
                    &[
                            "<!--",
                            "@*",
                    ],
            
            
            Ruby =>
                    &[
                            "=begin",
                    ],
            RubyHtml =>
                    &[
                            "<!--",
                    ],
            Rust =>
                    &[
                            "/*",
                    ],
            
            Sass =>
                    &[
                            "/*",
                    ],
            Scala =>
                    &[
                            "/*",
                    ],
            Scheme =>
                    &[
                            "#|",
                    ],
            
            
            Sml =>
                    &[
                            "(*",
                    ],
            Solidity =>
                    &[
                            "/*",
                    ],
            SpecmanE =>
                    &[
                            "'>",
                    ],
            
            Sql =>
                    &[
                            "/*",
                    ],
            Stratego =>
                    &[
                            "/*",
                    ],
            Svelte =>
                    &[
                            "/*",
                            "<!--",
                    ],
            Svg =>
                    &[
                            "<!--",
                    ],
            Swift =>
                    &[
                            "/*",
                    ],
            Swig =>
                    &[
                            "/*",
                    ],
            SystemVerilog =>
                    &[
                            "/*",
                    ],
            
            
            
            Thrift =>
                    &[
                            "/*",
                    ],
            
            Tsx =>
                    &[
                            "/*",
                    ],
            Twig =>
                    &[
                            "{#",
                    ],
            TypeScript =>
                    &[
                            "/*",
                    ],
            
            
            
            UnrealScript =>
                    &[
                            "/*",
                    ],
            UnrealShader =>
                    &[
                            "/*",
                    ],
            UnrealShaderHeader =>
                    &[
                            "/*",
                    ],
            UrWeb =>
                    &[
                            "(*",
                    ],
            
            
            
            Vala =>
                    &[
                            "/*",
                    ],
            Velocity =>
                    &[
                            "#*",
                    ],
            Verilog =>
                    &[
                            "/*",
                    ],
            
            
            
            
            VisualStudioProject =>
                    &[
                            "<!--",
                    ],
            
            Vue =>
                    &[
                            "<!--",
                            "/*",
                    ],
            
            Wolfram =>
                    &[
                            "(*",
                    ],
            XSL =>
                    &[
                            "<!--",
                    ],
            Xaml =>
                    &[
                            "<!--",
                    ],
            
            Xml =>
                    &[
                            "<!--",
                    ],
            Xtend =>
                    &[
                            "/*",
                    ],
            
            
            
            _ => &[],
        }
    }

    pub(crate) fn _end_multi_line_comments(self) -> &'static [&'static str] {
        match self {
            
            
            ActionScript =>
                    &[
                            "*/",
                    ],
            
            Agda =>
                    &[
                            "-}",
                    ],
            
            Arduino =>
                    &[
                            "*/",
                    ],
            Asn1 =>
                    &[
                            "*/",
                    ],
            
            AspNet =>
                    &[
                            "-->",
                            "-->",
                    ],
            
            AssemblyGAS =>
                    &[
                            "*/",
                    ],
            AutoHotKey =>
                    &[
                            "*/",
                    ],
            
            
            
            
            
            C =>
                    &[
                            "*/",
                    ],
            CHeader =>
                    &[
                            "*/",
                    ],
            
            CSharp =>
                    &[
                            "*/",
                    ],
            
            Cabal =>
                    &[
                            "-}",
                    ],
            Cassius =>
                    &[
                            "*/",
                    ],
            Ceylon =>
                    &[
                            "*/",
                    ],
            
            
            
            
            CoffeeScript =>
                    &[
                            "###",
                    ],
            
            ColdFusion =>
                    &[
                            "--->",
                    ],
            ColdFusionScript =>
                    &[
                            "*/",
                    ],
            Coq =>
                    &[
                            "*)",
                    ],
            Cpp =>
                    &[
                            "*/",
                    ],
            CppHeader =>
                    &[
                            "*/",
                    ],
            
            Css =>
                    &[
                            "*/",
                    ],
            D =>
                    &[
                            "*/",
                    ],
            Dart =>
                    &[
                            "*/",
                    ],
            DeviceTree =>
                    &[
                            "*/",
                    ],
            Dhall =>
                    &[
                            "-}",
                    ],
            
            DotNetResource =>
                    &[
                            "-->",
                    ],
            DreamMaker =>
                    &[
                            "*/",
                    ],
            Dust =>
                    &[
                            "!}",
                    ],
            
            
            
            Elm =>
                    &[
                            "-}",
                    ],
            
            
            Emojicode =>
                    &[
                            "🔚💭",
                            "📗",
                            "📘",
                    ],
            
            
            FSharp =>
                    &[
                            "*)",
                    ],
            
            FlatBuffers =>
                    &[
                            "*/",
                    ],
            Forth =>
                    &[
                            ")",
                    ],
            
            
            FreeMarker =>
                    &[
                            "-->",
                    ],
            Fstar =>
                    &[
                            "*)",
                    ],
            
            
            
            
            Glsl =>
                    &[
                            "*/",
                    ],
            Go =>
                    &[
                            "*/",
                    ],
            Gohtml =>
                    &[
                            "-->",
                            "*/}}",
                    ],
            
            Groovy =>
                    &[
                            "*/",
                    ],
            Hamlet =>
                    &[
                            "-->",
                    ],
            Handlebars =>
                    &[
                            "-->",
                            "}}",
                    ],
            
            Haskell =>
                    &[
                            "-}",
                    ],
            Haxe =>
                    &[
                            "*/",
                    ],
            Hcl =>
                    &[
                            "*/",
                    ],
            Headache =>
                    &[
                            "*/",
                    ],
            
            Hlsl =>
                    &[
                            "*/",
                    ],
            HolyC =>
                    &[
                            "*/",
                    ],
            Html =>
                    &[
                            "-->",
                            "*/",
                    ],
            Idris =>
                    &[
                            "-}",
                    ],
            
            
            Isabelle =>
                    &[
                            "*}",
                            "*)",
                            "›",
                            "\\<close>",
                    ],
            Jai =>
                    &[
                            "*/",
                    ],
            Java =>
                    &[
                            "*/",
                    ],
            JavaScript =>
                    &[
                            "*/",
                    ],
            
            Jsx =>
                    &[
                            "*/",
                    ],
            Julia =>
                    &[
                            "=#",
                    ],
            Julius =>
                    &[
                            "*/",
                    ],
            
            Kotlin =>
                    &[
                            "*/",
                    ],
            
            Lean =>
                    &[
                            "-/",
                    ],
            Less =>
                    &[
                            "*/",
                    ],
            LinkerScript =>
                    &[
                            "*/",
                    ],
            Liquid =>
                    &[
                            "{% endcomment %}",
                    ],
            Lisp =>
                    &[
                            "|#",
                    ],
            Logtalk =>
                    &[
                            "*/",
                    ],
            Lua =>
                    &[
                            "]]",
                    ],
            Lucius =>
                    &[
                            "*/",
                    ],
            Madlang =>
                    &[
                            "#}",
                    ],
            
            
            
            
            
            
            MsBuild =>
                    &[
                            "-->",
                    ],
            Mustache =>
                    &[
                            "}}",
                    ],
            
            Nix =>
                    &[
                            "*/",
                    ],
            NotQuitePerl =>
                    &[
                            "=end",
                    ],
            OCaml =>
                    &[
                            "*)",
                    ],
            ObjectiveC =>
                    &[
                            "*/",
                    ],
            ObjectiveCpp =>
                    &[
                            "*/",
                    ],
            Odin =>
                    &[
                            "*/",
                    ],
            
            
            Oz =>
                    &[
                            "*/",
                    ],
            PSL =>
                    &[
                            "*/",
                    ],
            
            Pascal =>
                    &[
                            "}",
                            "*)",
                    ],
            Perl =>
                    &[
                            "=cut",
                    ],
            Perl6 =>
                    &[
                            "=end",
                    ],
            
            Php =>
                    &[
                            "*/",
                    ],
            Polly =>
                    &[
                            "-->",
                    ],
            Pony =>
                    &[
                            "*/",
                    ],
            PostCss =>
                    &[
                            "*/",
                    ],
            PowerShell =>
                    &[
                            "#>",
                    ],
            Processing =>
                    &[
                            "*/",
                    ],
            Prolog =>
                    &[
                            "*/",
                    ],
            
            PureScript =>
                    &[
                            "-}",
                    ],
            
            Qcl =>
                    &[
                            "*/",
                    ],
            Qml =>
                    &[
                            "*/",
                    ],
            
            RON =>
                    &[
                            "*/",
                    ],
            
            Racket =>
                    &[
                            "|#",
                    ],
            Rakefile =>
                    &[
                            "=end",
                    ],
            Razor =>
                    &[
                            "-->",
                            "*@",
                    ],
            
            
            Ruby =>
                    &[
                            "=end",
                    ],
            RubyHtml =>
                    &[
                            "-->",
                    ],
            Rust =>
                    &[
                            "*/",
                    ],
            
            Sass =>
                    &[
                            "*/",
                    ],
            Scala =>
                    &[
                            "*/",
                    ],
            Scheme =>
                    &[
                            "|#",
                    ],
            
            
            Sml =>
                    &[
                            "*)",
                    ],
            Solidity =>
                    &[
                            "*/",
                    ],
            SpecmanE =>
                    &[
                            "<'",
                    ],
            
            Sql =>
                    &[
                            "*/",
                    ],
            Stratego =>
                    &[
                            "*/",
                    ],
            Svelte =>
                    &[
                            "*/",
                            "-->",
                    ],
            Svg =>
                    &[
                            "-->",
                    ],
            Swift =>
                    &[
                            "*/",
                    ],
            Swig =>
                    &[
                            "*/",
                    ],
            SystemVerilog =>
                    &[
                            "*/",
                    ],
            
            
            
            Thrift =>
                    &[
                            "*/",
                    ],
            
            Tsx =>
                    &[
                            "*/",
                    ],
            Twig =>
                    &[
                            "#}",
                    ],
            TypeScript =>
                    &[
                            "*/",
                    ],
            
            
            
            UnrealScript =>
                    &[
                            "*/",
                    ],
            UnrealShader =>
                    &[
                            "*/",
                    ],
            UnrealShaderHeader =>
                    &[
                            "*/",
                    ],
            UrWeb =>
                    &[
                            "*)",
                    ],
            
            
            
            Vala =>
                    &[
                            "*/",
                    ],
            Velocity =>
                    &[
                            "*#",
                    ],
            Verilog =>
                    &[
                            "*/",
                    ],
            
            
            
            
            VisualStudioProject =>
                    &[
                            "-->",
                    ],
            
            Vue =>
                    &[
                            "-->",
                            "*/",
                    ],
            
            Wolfram =>
                    &[
                            "*)",
                    ],
            XSL =>
                    &[
                            "-->",
                    ],
            Xaml =>
                    &[
                            "-->",
                    ],
            
            Xml =>
                    &[
                            "-->",
                    ],
            Xtend =>
                    &[
                            "*/",
                    ],
            
            
            
            _ => &[],
        }
    }

    pub(crate) fn _start_nested_comments(self) -> &'static [&'static str] {
        match self {
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            D =>
                    &[
                            "/+",
                    ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            _ => &[],
        }
    }

    pub(crate) fn _end_nested_comments(self) -> &'static [&'static str] {
        match self {
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            D =>
                    &[
                            "+/",
                    ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            _ => &[],
        }
    }

    /// Returns the starting doc literal.
    pub(crate) fn _start_doc_quotes(self) -> &'static [&'static str] {
        match self {
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            Pony =>
                    &[
                            "\"\"\"",
                    ],
            
            
            
            
            
            
            Python =>
                    &[
                            "\"\"\"",
                            "'''",
                    ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            _ => &[],
        }
    }

    /// Returns the starting doc literal.
    pub(crate) fn _end_doc_quotes(self) -> &'static [&'static str] {
        match self {
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            Pony =>
                    &[
                            "\"\"\"",
                    ],
            
            
            
            
            
            
            Python =>
                    &[
                            "\"\"\"",
                            "'''",
                    ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            _ => &[],
        }
    }

    /// Returns the parts of syntax that determines whether tokei can skip large
    /// parts of analysis.
    pub fn important_syntax(self) -> &'static [&'static str] {
        match self {
            Abap =>
                    &[
                        
                        
                        
                        
                    ],ActionScript =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Ada =>
                    &[
                        
                        
                        
                        
                    ],Agda =>
                    &[
                        
                        
                        "{-",
                        
                    ],Alex =>
                    &[
                        
                        
                        
                        
                    ],Arduino =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Asn1 =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],Asp =>
                    &[
                        
                        
                        
                        
                    ],AspNet =>
                    &[
                        
                        
                        "<!--","<%--",
                        
                    ],Assembly =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],AssemblyGAS =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],AutoHotKey =>
                    &[
                        
                        
                        "/*",
                        
                    ],Autoconf =>
                    &[
                        
                        
                        
                        
                    ],Automake =>
                    &[
                        
                        
                        
                        
                    ],Bash =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Batch =>
                    &[
                        
                        
                        
                        
                    ],BrightScript =>
                    &[
                        "\"",
                        
                        
                        
                    ],C =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],CHeader =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],CMake =>
                    &[
                        "\"",
                        
                        
                        
                    ],CSharp =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],CShell =>
                    &[
                        
                        
                        
                        
                    ],Cabal =>
                    &[
                        
                        
                        "{-",
                        
                    ],Cassius =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],Ceylon =>
                    &[
                        "\"\"\"","\"",
                        
                        "/*",
                        
                    ],Clojure =>
                    &[
                        "\"",
                        
                        
                        
                    ],ClojureC =>
                    &[
                        "\"",
                        
                        
                        
                    ],ClojureScript =>
                    &[
                        "\"",
                        
                        
                        
                    ],Cobol =>
                    &[
                        
                        
                        
                        
                    ],CoffeeScript =>
                    &[
                        "\"","'",
                        
                        "###",
                        
                    ],Cogent =>
                    &[
                        
                        
                        
                        
                    ],ColdFusion =>
                    &[
                        "\"","'",
                        
                        "<!---",
                        
                    ],ColdFusionScript =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Coq =>
                    &[
                        "\"",
                        
                        "(*",
                        
                    ],Cpp =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],CppHeader =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Crystal =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Css =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],D =>
                    &[
                        "\"","'",
                        
                        "/*",
                        "/+",
                    ],Dart =>
                    &[
                        "\"\"\"","'''","\"","'",
                        
                        "/*",
                        
                    ],DeviceTree =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Dhall =>
                    &[
                        "\"","''",
                        
                        "{-",
                        
                    ],Dockerfile =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],DotNetResource =>
                    &[
                        "\"",
                        
                        "<!--",
                        
                    ],DreamMaker =>
                    &[
                        "{\"","'",
                        
                        "/*",
                        
                    ],Dust =>
                    &[
                        
                        
                        "{!",
                        
                    ],Edn =>
                    &[
                        
                        
                        
                        
                    ],Elisp =>
                    &[
                        
                        
                        
                        
                    ],Elixir =>
                    &[
                        "\"\"\"","'''","\"","'",
                        
                        
                        
                    ],Elm =>
                    &[
                        
                        
                        "{-",
                        
                    ],Elvish =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],EmacsDevEnv =>
                    &[
                        
                        
                        
                        
                    ],Emojicode =>
                    &[
                        "❌🔤",
                        
                        "💭🔜","📗","📘",
                        
                    ],Erlang =>
                    &[
                        
                        
                        
                        
                    ],FEN =>
                    &[
                        
                        
                        
                        
                    ],FSharp =>
                    &[
                        "\"",
                        
                        "(*",
                        
                    ],Fish =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],FlatBuffers =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Forth =>
                    &[
                        
                        
                        "( ",
                        
                    ],FortranLegacy =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],FortranModern =>
                    &[
                        "\"",
                        
                        
                        
                    ],FreeMarker =>
                    &[
                        
                        
                        "<#--",
                        
                    ],Fstar =>
                    &[
                        "\"",
                        
                        "(*",
                        
                    ],Futhark =>
                    &[
                        
                        
                        
                        
                    ],GDB =>
                    &[
                        
                        
                        
                        
                    ],GdScript =>
                    &[
                        "\"\"\"","\"","'",
                        
                        
                        
                    ],Gherkin =>
                    &[
                        
                        
                        
                        
                    ],Glsl =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Go =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Gohtml =>
                    &[
                        "\"","'",
                        
                        "<!--","{{/*",
                        
                    ],Graphql =>
                    &[
                        "\"\"\"","\"",
                        
                        
                        
                    ],Groovy =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Hamlet =>
                    &[
                        "\"","'",
                        
                        "<!--",
                        
                    ],Handlebars =>
                    &[
                        "\"","'",
                        
                        "<!--","{{!",
                        
                    ],Happy =>
                    &[
                        
                        
                        
                        
                    ],Haskell =>
                    &[
                        
                        
                        "{-",
                        
                    ],Haxe =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],Hcl =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Headache =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Hex =>
                    &[
                        
                        
                        
                        
                    ],Hlsl =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],HolyC =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Html =>
                    &[
                        "\"","'","`",
                        
                        "<!--","/*",
                        
                    ],Idris =>
                    &[
                        "\"\"\"","\"",
                        
                        "{-",
                        
                    ],Ini =>
                    &[
                        
                        
                        
                        
                    ],IntelHex =>
                    &[
                        
                        
                        
                        
                    ],Isabelle =>
                    &[
                        "''",
                        
                        "{*","(*","‹","\\<open>",
                        
                    ],Jai =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Java =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],JavaScript =>
                    &[
                        "\"","'","`",
                        
                        "/*",
                        
                    ],Json =>
                    &[
                        
                        
                        
                        
                    ],Jsx =>
                    &[
                        "\"","'","`",
                        
                        "/*",
                        
                    ],Julia =>
                    &[
                        "\"\"\"","\"",
                        
                        "#=",
                        
                    ],Julius =>
                    &[
                        "\"","'","`",
                        
                        "/*",
                        
                    ],KakouneScript =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Kotlin =>
                    &[
                        "\"\"\"","\"",
                        
                        "/*",
                        
                    ],LLVM =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Lean =>
                    &[
                        
                        
                        "/-",
                        
                    ],Less =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],LinkerScript =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Liquid =>
                    &[
                        "\"","'",
                        
                        "{% comment %}",
                        
                    ],Lisp =>
                    &[
                        
                        
                        "#|",
                        
                    ],Logtalk =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Lua =>
                    &[
                        "\"","'",
                        
                        "--[[",
                        
                    ],Lucius =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],Madlang =>
                    &[
                        
                        
                        "{#",
                        
                    ],Makefile =>
                    &[
                        
                        
                        
                        
                    ],Markdown =>
                    &[
                        
                        
                        
                        
                    ],Meson =>
                    &[
                        "'''","'",
                        
                        
                        
                    ],Mint =>
                    &[
                        
                        
                        
                        
                    ],ModuleDef =>
                    &[
                        
                        
                        
                        
                    ],MoonScript =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],MsBuild =>
                    &[
                        "\"","'",
                        
                        "<!--",
                        
                    ],Mustache =>
                    &[
                        "\"","'",
                        
                        "{{!",
                        
                    ],Nim =>
                    &[
                        "\"\"\"","\"",
                        
                        
                        
                    ],Nix =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],NotQuitePerl =>
                    &[
                        "\"","'",
                        
                        "=begin",
                        
                    ],OCaml =>
                    &[
                        "\"",
                        
                        "(*",
                        
                    ],ObjectiveC =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],ObjectiveCpp =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Odin =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],OpenType =>
                    &[
                        
                        
                        
                        
                    ],Org =>
                    &[
                        
                        
                        
                        
                    ],Oz =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],PSL =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Pan =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Pascal =>
                    &[
                        "'",
                        
                        "{","(*",
                        
                    ],Perl =>
                    &[
                        "\"","'",
                        
                        "=pod",
                        
                    ],Perl6 =>
                    &[
                        "\"","'",
                        
                        "=begin",
                        
                    ],Pest =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Php =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],Polly =>
                    &[
                        "\"","'",
                        
                        "<!--",
                        
                    ],Pony =>
                    &[
                        "\"",
                        "\"\"\"",
                        "/*",
                        
                    ],PostCss =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],PowerShell =>
                    &[
                        "\"@","\"","@'","'",
                        
                        "<#",
                        
                    ],Processing =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Prolog =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Protobuf =>
                    &[
                        
                        
                        
                        
                    ],PureScript =>
                    &[
                        
                        
                        "{-",
                        
                    ],Python =>
                    &[
                        "\"","'",
                        "\"\"\"","'''",
                        
                        
                    ],Qcl =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Qml =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],R =>
                    &[
                        
                        
                        
                        
                    ],RON =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],RPMSpecfile =>
                    &[
                        
                        
                        
                        
                    ],Racket =>
                    &[
                        
                        
                        "#|",
                        
                    ],Rakefile =>
                    &[
                        "\"","'",
                        
                        "=begin",
                        
                    ],Razor =>
                    &[
                        
                        
                        "<!--","@*",
                        
                    ],ReStructuredText =>
                    &[
                        
                        
                        
                        
                    ],Renpy =>
                    &[
                        "\"","'","`",
                        
                        
                        
                    ],Ruby =>
                    &[
                        "\"","'",
                        
                        "=begin",
                        
                    ],RubyHtml =>
                    &[
                        "\"","'",
                        
                        "<!--",
                        
                    ],Rust =>
                    &[
                        "r#\"","#\"","\"",
                        
                        "/*",
                        
                    ],SRecode =>
                    &[
                        
                        
                        
                        
                    ],Sass =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],Scala =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Scheme =>
                    &[
                        
                        
                        "#|",
                        
                    ],Scons =>
                    &[
                        "\"\"\"","'''","\"","'",
                        
                        
                        
                    ],Sh =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Sml =>
                    &[
                        "\"",
                        
                        "(*",
                        
                    ],Solidity =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],SpecmanE =>
                    &[
                        
                        
                        "'>",
                        
                    ],Spice =>
                    &[
                        
                        
                        
                        
                    ],Sql =>
                    &[
                        "'",
                        
                        "/*",
                        
                    ],Stratego =>
                    &[
                        "\"","$[","$<","${",
                        
                        "/*",
                        
                    ],Svelte =>
                    &[
                        "\"","'","`",
                        
                        "/*","<!--",
                        
                    ],Svg =>
                    &[
                        "\"","'",
                        
                        "<!--",
                        
                    ],Swift =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Swig =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],SystemVerilog =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Tcl =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Tex =>
                    &[
                        
                        
                        
                        
                    ],Text =>
                    &[
                        
                        
                        
                        
                    ],Thrift =>
                    &[
                        "\"","'",
                        
                        "/*",
                        
                    ],Toml =>
                    &[
                        "\"\"\"","'''","\"","'",
                        
                        
                        
                    ],Tsx =>
                    &[
                        "\"","'","`",
                        
                        "/*",
                        
                    ],Twig =>
                    &[
                        "\"","'",
                        
                        "{#",
                        
                    ],TypeScript =>
                    &[
                        "\"","'","`",
                        
                        "/*",
                        
                    ],UnrealDeveloperMarkdown =>
                    &[
                        
                        
                        
                        
                    ],UnrealPlugin =>
                    &[
                        
                        
                        
                        
                    ],UnrealProject =>
                    &[
                        
                        
                        
                        
                    ],UnrealScript =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],UnrealShader =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],UnrealShaderHeader =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],UrWeb =>
                    &[
                        "\"",
                        
                        "(*",
                        
                    ],UrWebProject =>
                    &[
                        
                        
                        
                        
                    ],VB6 =>
                    &[
                        
                        
                        
                        
                    ],VBScript =>
                    &[
                        
                        
                        
                        
                    ],Vala =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],Velocity =>
                    &[
                        "\"","'",
                        
                        "#*",
                        
                    ],Verilog =>
                    &[
                        "\"",
                        
                        "/*",
                        
                    ],VerilogArgsFile =>
                    &[
                        
                        
                        
                        
                    ],Vhdl =>
                    &[
                        
                        
                        
                        
                    ],VimScript =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],VisualBasic =>
                    &[
                        "\"",
                        
                        
                        
                    ],VisualStudioProject =>
                    &[
                        "\"","'",
                        
                        "<!--",
                        
                    ],VisualStudioSolution =>
                    &[
                        
                        
                        
                        
                    ],Vue =>
                    &[
                        "\"","'","`",
                        
                        "<!--","/*",
                        
                    ],WebAssembly =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Wolfram =>
                    &[
                        "\"",
                        
                        "(*",
                        
                    ],XSL =>
                    &[
                        "\"","'",
                        
                        "<!--",
                        
                    ],Xaml =>
                    &[
                        "\"","'",
                        
                        "<!--",
                        
                    ],XcodeConfig =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Xml =>
                    &[
                        "\"","'",
                        
                        "<!--",
                        
                    ],Xtend =>
                    &[
                        "'''","\"","'",
                        
                        "/*",
                        
                    ],Yaml =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],Zig =>
                    &[
                        "\"","\\",
                        
                        
                        
                    ],Zsh =>
                    &[
                        "\"","'",
                        
                        
                        
                    ],
        }
    }

    /// Get language from a file path. May open and read the file.
    ///
    /// ```no_run
    /// use tokei::{Config, LanguageType};
    ///
    /// let rust = LanguageType::from_path("./main.rs", &Config::default());
    ///
    /// assert_eq!(rust, Some(LanguageType::Rust));
    /// ```
    pub fn from_path<P: AsRef<Path>>(entry: P, _config: &Config)
        -> Option<Self>
    {
        let entry = entry.as_ref();

        if let Some(filename) = fsutils::get_filename(&entry) {
            match &*filename {
                            "cmakelists.txt"
                            => return Some(CMake),
                            "dockerfile"
                            => return Some(Dockerfile),
                            "makefile"
                            => return Some(Makefile),
                            "meson.build" |
                            "meson_options.txt"
                            => return Some(Meson),
                            "rakefile"
                            => return Some(Rakefile),
                            "sconstruct" |
                            "sconscript"
                            => return Some(Scons),
                _ => ()
            }
        }

        let extension = fsutils::get_extension(&entry);
        match extension {
            Some(extension) => LanguageType::from_file_extension(extension.as_str()),
            None => LanguageType::from_shebang(&entry),
        }
    }

    /// Get language from a file extension.
    ///
    /// ```no_run
    /// use tokei::LanguageType;
    ///
    /// let rust = LanguageType::from_file_extension("rs");
    ///
    /// assert_eq!(rust, Some(LanguageType::Rust));
    /// ```
    pub fn from_file_extension(extension: &str) -> Option<Self> {
        match extension {
                        | "abap"
                        => Some(Abap),
                        | "as"
                        => Some(ActionScript),
                        | "ada"
                        | "adb"
                        | "ads"
                        | "pad"
                        => Some(Ada),
                        | "agda"
                        => Some(Agda),
                        | "x"
                        => Some(Alex),
                        | "ino"
                        => Some(Arduino),
                        | "asn1"
                        => Some(Asn1),
                        | "asa"
                        | "asp"
                        => Some(Asp),
                        | "asax"
                        | "ascx"
                        | "asmx"
                        | "aspx"
                        | "master"
                        | "sitemap"
                        | "webinfo"
                        => Some(AspNet),
                        | "asm"
                        => Some(Assembly),
                        | "s"
                        => Some(AssemblyGAS),
                        | "ahk"
                        => Some(AutoHotKey),
                        | "in"
                        => Some(Autoconf),
                        | "am"
                        => Some(Automake),
                        | "bash"
                        => Some(Bash),
                        | "bat"
                        | "btm"
                        | "cmd"
                        => Some(Batch),
                        | "brs"
                        => Some(BrightScript),
                        | "c"
                        | "ec"
                        | "pgc"
                        => Some(C),
                        | "h"
                        => Some(CHeader),
                        | "cmake"
                        => Some(CMake),
                        | "cs"
                        => Some(CSharp),
                        | "csh"
                        => Some(CShell),
                        | "cabal"
                        => Some(Cabal),
                        | "cassius"
                        => Some(Cassius),
                        | "ceylon"
                        => Some(Ceylon),
                        | "clj"
                        => Some(Clojure),
                        | "cljc"
                        => Some(ClojureC),
                        | "cljs"
                        => Some(ClojureScript),
                        | "cob"
                        | "cbl"
                        | "ccp"
                        | "cobol"
                        | "cpy"
                        => Some(Cobol),
                        | "coffee"
                        | "cjsx"
                        => Some(CoffeeScript),
                        | "cogent"
                        => Some(Cogent),
                        | "cfm"
                        => Some(ColdFusion),
                        | "cfc"
                        => Some(ColdFusionScript),
                        | "v"
                        => Some(Coq),
                        | "cc"
                        | "cpp"
                        | "cxx"
                        | "c++"
                        | "pcc"
                        | "tpp"
                        => Some(Cpp),
                        | "hh"
                        | "hpp"
                        | "hxx"
                        | "inl"
                        | "ipp"
                        => Some(CppHeader),
                        | "cr"
                        => Some(Crystal),
                        | "css"
                        => Some(Css),
                        | "d"
                        => Some(D),
                        | "dart"
                        => Some(Dart),
                        | "dts"
                        | "dtsi"
                        => Some(DeviceTree),
                        | "dhall"
                        => Some(Dhall),
                        | "dockerfile"
                        | "dockerignore"
                        => Some(Dockerfile),
                        | "resx"
                        => Some(DotNetResource),
                        | "dm"
                        | "dme"
                        => Some(DreamMaker),
                        | "dust"
                        => Some(Dust),
                        | "edn"
                        => Some(Edn),
                        | "el"
                        => Some(Elisp),
                        | "ex"
                        | "exs"
                        => Some(Elixir),
                        | "elm"
                        => Some(Elm),
                        | "elv"
                        => Some(Elvish),
                        | "ede"
                        => Some(EmacsDevEnv),
                        | "emojic"
                        | "🍇"
                        => Some(Emojicode),
                        | "erl"
                        | "hrl"
                        => Some(Erlang),
                        | "fen"
                        => Some(FEN),
                        | "fs"
                        | "fsi"
                        | "fsx"
                        | "fsscript"
                        => Some(FSharp),
                        | "fish"
                        => Some(Fish),
                        | "fbs"
                        => Some(FlatBuffers),
                        | "4th"
                        | "forth"
                        | "fr"
                        | "frt"
                        | "fth"
                        | "f83"
                        | "fb"
                        | "fpm"
                        | "e4"
                        | "rx"
                        | "ft"
                        => Some(Forth),
                        | "f"
                        | "for"
                        | "ftn"
                        | "f77"
                        | "pfo"
                        => Some(FortranLegacy),
                        | "f03"
                        | "f08"
                        | "f90"
                        | "f95"
                        => Some(FortranModern),
                        | "ftl"
                        | "ftlh"
                        | "ftlx"
                        => Some(FreeMarker),
                        | "fst"
                        => Some(Fstar),
                        | "fut"
                        => Some(Futhark),
                        | "gdb"
                        => Some(GDB),
                        | "gd"
                        => Some(GdScript),
                        | "feature"
                        => Some(Gherkin),
                        | "vert"
                        | "tesc"
                        | "tese"
                        | "geom"
                        | "frag"
                        | "comp"
                        | "glsl"
                        => Some(Glsl),
                        | "go"
                        => Some(Go),
                        | "gohtml"
                        => Some(Gohtml),
                        | "gql"
                        | "graphql"
                        => Some(Graphql),
                        | "groovy"
                        | "grt"
                        | "gtpl"
                        | "gvy"
                        => Some(Groovy),
                        | "hamlet"
                        => Some(Hamlet),
                        | "hbs"
                        | "handlebars"
                        => Some(Handlebars),
                        | "y"
                        | "ly"
                        => Some(Happy),
                        | "hs"
                        => Some(Haskell),
                        | "hx"
                        => Some(Haxe),
                        | "tf"
                        | "tfvars"
                        => Some(Hcl),
                        | "ha"
                        => Some(Headache),
                        | "hex"
                        => Some(Hex),
                        | "hlsl"
                        => Some(Hlsl),
                        | "HC"
                        | "hc"
                        => Some(HolyC),
                        | "html"
                        | "htm"
                        => Some(Html),
                        | "idr"
                        | "lidr"
                        => Some(Idris),
                        | "ini"
                        => Some(Ini),
                        | "ihex"
                        => Some(IntelHex),
                        | "thy"
                        => Some(Isabelle),
                        | "jai"
                        => Some(Jai),
                        | "java"
                        => Some(Java),
                        | "js"
                        | "mjs"
                        => Some(JavaScript),
                        | "json"
                        => Some(Json),
                        | "jsx"
                        => Some(Jsx),
                        | "jl"
                        => Some(Julia),
                        | "julius"
                        => Some(Julius),
                        | "kak"
                        => Some(KakouneScript),
                        | "kt"
                        | "kts"
                        => Some(Kotlin),
                        | "ll"
                        => Some(LLVM),
                        | "lean"
                        | "hlean"
                        => Some(Lean),
                        | "less"
                        => Some(Less),
                        | "lds"
                        => Some(LinkerScript),
                        | "liquid"
                        => Some(Liquid),
                        | "lisp"
                        | "lsp"
                        => Some(Lisp),
                        | "lgt"
                        | "logtalk"
                        => Some(Logtalk),
                        | "lua"
                        => Some(Lua),
                        | "lucius"
                        => Some(Lucius),
                        | "mad"
                        => Some(Madlang),
                        | "makefile"
                        | "mak"
                        | "mk"
                        => Some(Makefile),
                        | "md"
                        | "markdown"
                        => Some(Markdown),
                        | "mint"
                        => Some(Mint),
                        | "def"
                        => Some(ModuleDef),
                        | "moon"
                        => Some(MoonScript),
                        | "csproj"
                        | "vbproj"
                        | "fsproj"
                        | "props"
                        | "targets"
                        => Some(MsBuild),
                        | "mustache"
                        => Some(Mustache),
                        | "nim"
                        => Some(Nim),
                        | "nix"
                        => Some(Nix),
                        | "nqp"
                        => Some(NotQuitePerl),
                        | "ml"
                        | "mli"
                        | "re"
                        | "rei"
                        => Some(OCaml),
                        | "m"
                        => Some(ObjectiveC),
                        | "mm"
                        => Some(ObjectiveCpp),
                        | "odin"
                        => Some(Odin),
                        | "fea"
                        => Some(OpenType),
                        | "org"
                        => Some(Org),
                        | "oz"
                        => Some(Oz),
                        | "psl"
                        => Some(PSL),
                        | "pan"
                        | "tpl"
                        => Some(Pan),
                        | "pas"
                        | "pp"
                        => Some(Pascal),
                        | "pl"
                        | "pm"
                        => Some(Perl),
                        | "pl6"
                        | "pm6"
                        => Some(Perl6),
                        | "pest"
                        => Some(Pest),
                        | "php"
                        => Some(Php),
                        | "polly"
                        => Some(Polly),
                        | "pony"
                        => Some(Pony),
                        | "pcss"
                        | "sss"
                        => Some(PostCss),
                        | "ps1"
                        | "psm1"
                        | "psd1"
                        | "ps1xml"
                        | "cdxml"
                        | "pssc"
                        | "psc1"
                        => Some(PowerShell),
                        | "pde"
                        => Some(Processing),
                        | "p"
                        | "pro"
                        => Some(Prolog),
                        | "proto"
                        => Some(Protobuf),
                        | "purs"
                        => Some(PureScript),
                        | "py"
                        | "pyw"
                        => Some(Python),
                        | "qcl"
                        => Some(Qcl),
                        | "qml"
                        => Some(Qml),
                        | "r"
                        => Some(R),
                        | "ron"
                        => Some(RON),
                        | "spec"
                        => Some(RPMSpecfile),
                        | "rkt"
                        => Some(Racket),
                        | "rake"
                        => Some(Rakefile),
                        | "cshtml"
                        => Some(Razor),
                        | "rst"
                        => Some(ReStructuredText),
                        | "rpy"
                        => Some(Renpy),
                        | "rb"
                        => Some(Ruby),
                        | "rhtml"
                        | "erb"
                        => Some(RubyHtml),
                        | "rs"
                        => Some(Rust),
                        | "srt"
                        => Some(SRecode),
                        | "sass"
                        | "scss"
                        => Some(Sass),
                        | "sc"
                        | "scala"
                        => Some(Scala),
                        | "scm"
                        | "ss"
                        => Some(Scheme),
                        | "sh"
                        => Some(Sh),
                        | "sml"
                        => Some(Sml),
                        | "sol"
                        => Some(Solidity),
                        | "e"
                        => Some(SpecmanE),
                        | "ckt"
                        => Some(Spice),
                        | "sql"
                        => Some(Sql),
                        | "str"
                        => Some(Stratego),
                        | "svelte"
                        => Some(Svelte),
                        | "svg"
                        => Some(Svg),
                        | "swift"
                        => Some(Swift),
                        | "swg"
                        | "i"
                        => Some(Swig),
                        | "sv"
                        | "svh"
                        => Some(SystemVerilog),
                        | "tcl"
                        => Some(Tcl),
                        | "tex"
                        | "sty"
                        => Some(Tex),
                        | "text"
                        | "txt"
                        => Some(Text),
                        | "thrift"
                        => Some(Thrift),
                        | "toml"
                        => Some(Toml),
                        | "tsx"
                        => Some(Tsx),
                        | "twig"
                        => Some(Twig),
                        | "ts"
                        => Some(TypeScript),
                        | "udn"
                        => Some(UnrealDeveloperMarkdown),
                        | "uplugin"
                        => Some(UnrealPlugin),
                        | "uproject"
                        => Some(UnrealProject),
                        | "uc"
                        | "uci"
                        | "upkg"
                        => Some(UnrealScript),
                        | "usf"
                        => Some(UnrealShader),
                        | "ush"
                        => Some(UnrealShaderHeader),
                        | "ur"
                        | "urs"
                        => Some(UrWeb),
                        | "urp"
                        => Some(UrWebProject),
                        | "frm"
                        | "bas"
                        | "cls"
                        => Some(VB6),
                        | "vbs"
                        => Some(VBScript),
                        | "vala"
                        => Some(Vala),
                        | "vm"
                        => Some(Velocity),
                        | "vg"
                        | "vh"
                        => Some(Verilog),
                        | "irunargs"
                        | "xrunargs"
                        => Some(VerilogArgsFile),
                        | "vhd"
                        | "vhdl"
                        => Some(Vhdl),
                        | "vim"
                        => Some(VimScript),
                        | "vb"
                        => Some(VisualBasic),
                        | "vcproj"
                        | "vcxproj"
                        => Some(VisualStudioProject),
                        | "sln"
                        => Some(VisualStudioSolution),
                        | "vue"
                        => Some(Vue),
                        | "wat"
                        | "wast"
                        => Some(WebAssembly),
                        | "nb"
                        | "wl"
                        => Some(Wolfram),
                        | "xsl"
                        | "xslt"
                        => Some(XSL),
                        | "xaml"
                        => Some(Xaml),
                        | "xcconfig"
                        => Some(XcodeConfig),
                        | "xml"
                        => Some(Xml),
                        | "xtend"
                        => Some(Xtend),
                        | "yaml"
                        | "yml"
                        => Some(Yaml),
                        | "zig"
                        => Some(Zig),
                        | "zsh"
                        => Some(Zsh),
            extension => {
                warn!("Unknown extension: {}", extension);
                None
            },
        }
    }

    /// Get language from a shebang. May open and read the file.
    ///
    /// ```no_run
    /// use tokei::LanguageType;
    ///
    /// let rust = LanguageType::from_shebang("./main.rs");
    ///
    /// assert_eq!(rust, Some(LanguageType::Rust));
    /// ```
    pub fn from_shebang<P: AsRef<Path>>(entry: P) -> Option<Self> {
        if let Some(filetype) = get_filetype_from_shebang(entry.as_ref()) {
            match filetype {
                    "Abap" => Some(Abap),
                    "ActionScript" => Some(ActionScript),
                    "Ada" => Some(Ada),
                    "Agda" => Some(Agda),
                    "Alex" => Some(Alex),
                    "Arduino" => Some(Arduino),
                    "Asn1" => Some(Asn1),
                    "Asp" => Some(Asp),
                    "AspNet" => Some(AspNet),
                    "Assembly" => Some(Assembly),
                    "AssemblyGAS" => Some(AssemblyGAS),
                    "AutoHotKey" => Some(AutoHotKey),
                    "Autoconf" => Some(Autoconf),
                    "Automake" => Some(Automake),
                    "Bash" => Some(Bash),
                    "Batch" => Some(Batch),
                    "BrightScript" => Some(BrightScript),
                    "C" => Some(C),
                    "CHeader" => Some(CHeader),
                    "CMake" => Some(CMake),
                    "CSharp" => Some(CSharp),
                    "CShell" => Some(CShell),
                    "Cabal" => Some(Cabal),
                    "Cassius" => Some(Cassius),
                    "Ceylon" => Some(Ceylon),
                    "Clojure" => Some(Clojure),
                    "ClojureC" => Some(ClojureC),
                    "ClojureScript" => Some(ClojureScript),
                    "Cobol" => Some(Cobol),
                    "CoffeeScript" => Some(CoffeeScript),
                    "Cogent" => Some(Cogent),
                    "ColdFusion" => Some(ColdFusion),
                    "ColdFusionScript" => Some(ColdFusionScript),
                    "Coq" => Some(Coq),
                    "Cpp" => Some(Cpp),
                    "CppHeader" => Some(CppHeader),
                    "Crystal" => Some(Crystal),
                    "Css" => Some(Css),
                    "D" => Some(D),
                    "Dart" => Some(Dart),
                    "DeviceTree" => Some(DeviceTree),
                    "Dhall" => Some(Dhall),
                    "Dockerfile" => Some(Dockerfile),
                    "DotNetResource" => Some(DotNetResource),
                    "DreamMaker" => Some(DreamMaker),
                    "Dust" => Some(Dust),
                    "Edn" => Some(Edn),
                    "Elisp" => Some(Elisp),
                    "Elixir" => Some(Elixir),
                    "Elm" => Some(Elm),
                    "Elvish" => Some(Elvish),
                    "EmacsDevEnv" => Some(EmacsDevEnv),
                    "Emojicode" => Some(Emojicode),
                    "Erlang" => Some(Erlang),
                    "FEN" => Some(FEN),
                    "FSharp" => Some(FSharp),
                    "Fish" => Some(Fish),
                    "FlatBuffers" => Some(FlatBuffers),
                    "Forth" => Some(Forth),
                    "FortranLegacy" => Some(FortranLegacy),
                    "FortranModern" => Some(FortranModern),
                    "FreeMarker" => Some(FreeMarker),
                    "Fstar" => Some(Fstar),
                    "Futhark" => Some(Futhark),
                    "GDB" => Some(GDB),
                    "GdScript" => Some(GdScript),
                    "Gherkin" => Some(Gherkin),
                    "Glsl" => Some(Glsl),
                    "Go" => Some(Go),
                    "Gohtml" => Some(Gohtml),
                    "Graphql" => Some(Graphql),
                    "Groovy" => Some(Groovy),
                    "Hamlet" => Some(Hamlet),
                    "Handlebars" => Some(Handlebars),
                    "Happy" => Some(Happy),
                    "Haskell" => Some(Haskell),
                    "Haxe" => Some(Haxe),
                    "Hcl" => Some(Hcl),
                    "Headache" => Some(Headache),
                    "Hex" => Some(Hex),
                    "Hlsl" => Some(Hlsl),
                    "HolyC" => Some(HolyC),
                    "Html" => Some(Html),
                    "Idris" => Some(Idris),
                    "Ini" => Some(Ini),
                    "IntelHex" => Some(IntelHex),
                    "Isabelle" => Some(Isabelle),
                    "Jai" => Some(Jai),
                    "Java" => Some(Java),
                    "JavaScript" => Some(JavaScript),
                    "Json" => Some(Json),
                    "Jsx" => Some(Jsx),
                    "Julia" => Some(Julia),
                    "Julius" => Some(Julius),
                    "KakouneScript" => Some(KakouneScript),
                    "Kotlin" => Some(Kotlin),
                    "LLVM" => Some(LLVM),
                    "Lean" => Some(Lean),
                    "Less" => Some(Less),
                    "LinkerScript" => Some(LinkerScript),
                    "Liquid" => Some(Liquid),
                    "Lisp" => Some(Lisp),
                    "Logtalk" => Some(Logtalk),
                    "Lua" => Some(Lua),
                    "Lucius" => Some(Lucius),
                    "Madlang" => Some(Madlang),
                    "Makefile" => Some(Makefile),
                    "Markdown" => Some(Markdown),
                    "Meson" => Some(Meson),
                    "Mint" => Some(Mint),
                    "ModuleDef" => Some(ModuleDef),
                    "MoonScript" => Some(MoonScript),
                    "MsBuild" => Some(MsBuild),
                    "Mustache" => Some(Mustache),
                    "Nim" => Some(Nim),
                    "Nix" => Some(Nix),
                    "NotQuitePerl" => Some(NotQuitePerl),
                    "OCaml" => Some(OCaml),
                    "ObjectiveC" => Some(ObjectiveC),
                    "ObjectiveCpp" => Some(ObjectiveCpp),
                    "Odin" => Some(Odin),
                    "OpenType" => Some(OpenType),
                    "Org" => Some(Org),
                    "Oz" => Some(Oz),
                    "PSL" => Some(PSL),
                    "Pan" => Some(Pan),
                    "Pascal" => Some(Pascal),
                    "Perl" => Some(Perl),
                    "Perl6" => Some(Perl6),
                    "Pest" => Some(Pest),
                    "Php" => Some(Php),
                    "Polly" => Some(Polly),
                    "Pony" => Some(Pony),
                    "PostCss" => Some(PostCss),
                    "PowerShell" => Some(PowerShell),
                    "Processing" => Some(Processing),
                    "Prolog" => Some(Prolog),
                    "Protobuf" => Some(Protobuf),
                    "PureScript" => Some(PureScript),
                    "Python" => Some(Python),
                    "Qcl" => Some(Qcl),
                    "Qml" => Some(Qml),
                    "R" => Some(R),
                    "RON" => Some(RON),
                    "RPMSpecfile" => Some(RPMSpecfile),
                    "Racket" => Some(Racket),
                    "Rakefile" => Some(Rakefile),
                    "Razor" => Some(Razor),
                    "ReStructuredText" => Some(ReStructuredText),
                    "Renpy" => Some(Renpy),
                    "Ruby" => Some(Ruby),
                    "RubyHtml" => Some(RubyHtml),
                    "Rust" => Some(Rust),
                    "SRecode" => Some(SRecode),
                    "Sass" => Some(Sass),
                    "Scala" => Some(Scala),
                    "Scheme" => Some(Scheme),
                    "Scons" => Some(Scons),
                    "Sh" => Some(Sh),
                    "Sml" => Some(Sml),
                    "Solidity" => Some(Solidity),
                    "SpecmanE" => Some(SpecmanE),
                    "Spice" => Some(Spice),
                    "Sql" => Some(Sql),
                    "Stratego" => Some(Stratego),
                    "Svelte" => Some(Svelte),
                    "Svg" => Some(Svg),
                    "Swift" => Some(Swift),
                    "Swig" => Some(Swig),
                    "SystemVerilog" => Some(SystemVerilog),
                    "Tcl" => Some(Tcl),
                    "Tex" => Some(Tex),
                    "Text" => Some(Text),
                    "Thrift" => Some(Thrift),
                    "Toml" => Some(Toml),
                    "Tsx" => Some(Tsx),
                    "Twig" => Some(Twig),
                    "TypeScript" => Some(TypeScript),
                    "UnrealDeveloperMarkdown" => Some(UnrealDeveloperMarkdown),
                    "UnrealPlugin" => Some(UnrealPlugin),
                    "UnrealProject" => Some(UnrealProject),
                    "UnrealScript" => Some(UnrealScript),
                    "UnrealShader" => Some(UnrealShader),
                    "UnrealShaderHeader" => Some(UnrealShaderHeader),
                    "UrWeb" => Some(UrWeb),
                    "UrWebProject" => Some(UrWebProject),
                    "VB6" => Some(VB6),
                    "VBScript" => Some(VBScript),
                    "Vala" => Some(Vala),
                    "Velocity" => Some(Velocity),
                    "Verilog" => Some(Verilog),
                    "VerilogArgsFile" => Some(VerilogArgsFile),
                    "Vhdl" => Some(Vhdl),
                    "VimScript" => Some(VimScript),
                    "VisualBasic" => Some(VisualBasic),
                    "VisualStudioProject" => Some(VisualStudioProject),
                    "VisualStudioSolution" => Some(VisualStudioSolution),
                    "Vue" => Some(Vue),
                    "WebAssembly" => Some(WebAssembly),
                    "Wolfram" => Some(Wolfram),
                    "XSL" => Some(XSL),
                    "Xaml" => Some(Xaml),
                    "XcodeConfig" => Some(XcodeConfig),
                    "Xml" => Some(Xml),
                    "Xtend" => Some(Xtend),
                    "Yaml" => Some(Yaml),
                    "Zig" => Some(Zig),
                    "Zsh" => Some(Zsh),
                extension => {
                    warn!("Unknown extension: {}", extension);
                    None
                },
            }
        } else {
            None
        }
    }
}

impl FromStr for LanguageType {
    type Err = &'static str;

    fn from_str(from: &str) -> Result<Self, Self::Err> {
        match &*from {
                    "ABAP"
                
                    => Ok(Abap),
                    "ActionScript"
                    => Ok(ActionScript),
                    "Ada"
                    => Ok(Ada),
                    "Agda"
                    => Ok(Agda),
                    "Alex"
                    => Ok(Alex),
                    "Arduino C++"
                
                    => Ok(Arduino),
                    "ASN.1"
                
                    => Ok(Asn1),
                    "ASP"
                
                    => Ok(Asp),
                    "ASP.NET"
                
                    => Ok(AspNet),
                    "Assembly"
                    => Ok(Assembly),
                    "GNU Style Assembly"
                
                    => Ok(AssemblyGAS),
                    "AutoHotKey"
                    => Ok(AutoHotKey),
                    "Autoconf"
                    => Ok(Autoconf),
                    "Automake"
                    => Ok(Automake),
                    "BASH"
                
                    => Ok(Bash),
                    "Batch"
                    => Ok(Batch),
                    "BrightScript"
                    => Ok(BrightScript),
                    "C"
                    => Ok(C),
                    "C Header"
                
                    => Ok(CHeader),
                    "CMake"
                    => Ok(CMake),
                    "C#"
                
                    => Ok(CSharp),
                    "C Shell"
                
                    => Ok(CShell),
                    "Cabal"
                    => Ok(Cabal),
                    "Cassius"
                    => Ok(Cassius),
                    "Ceylon"
                    => Ok(Ceylon),
                    "Clojure"
                    => Ok(Clojure),
                    "ClojureC"
                    => Ok(ClojureC),
                    "ClojureScript"
                    => Ok(ClojureScript),
                    "COBOL"
                
                    => Ok(Cobol),
                    "CoffeeScript"
                    => Ok(CoffeeScript),
                    "Cogent"
                    => Ok(Cogent),
                    "ColdFusion"
                    => Ok(ColdFusion),
                    "ColdFusion CFScript"
                
                    => Ok(ColdFusionScript),
                    "Coq"
                    => Ok(Coq),
                    "C++"
                
                    => Ok(Cpp),
                    "C++ Header"
                
                    => Ok(CppHeader),
                    "Crystal"
                    => Ok(Crystal),
                    "CSS"
                
                    => Ok(Css),
                    "D"
                    => Ok(D),
                    "Dart"
                    => Ok(Dart),
                    "Device Tree"
                
                    => Ok(DeviceTree),
                    "Dhall"
                    => Ok(Dhall),
                    "Dockerfile"
                    => Ok(Dockerfile),
                    ".NET Resource"
                
                    => Ok(DotNetResource),
                    "Dream Maker"
                
                    => Ok(DreamMaker),
                    "Dust.js"
                
                    => Ok(Dust),
                    "Edn"
                    => Ok(Edn),
                    "Emacs Lisp"
                
                    => Ok(Elisp),
                    "Elixir"
                    => Ok(Elixir),
                    "Elm"
                    => Ok(Elm),
                    "Elvish"
                    => Ok(Elvish),
                    "Emacs Dev Env"
                
                    => Ok(EmacsDevEnv),
                    "Emojicode"
                    => Ok(Emojicode),
                    "Erlang"
                    => Ok(Erlang),
                    "FEN"
                
                    => Ok(FEN),
                    "F#"
                
                    => Ok(FSharp),
                    "Fish"
                    => Ok(Fish),
                    "FlatBuffers Schema"
                
                    => Ok(FlatBuffers),
                    "Forth"
                    => Ok(Forth),
                    "FORTRAN Legacy"
                
                    => Ok(FortranLegacy),
                    "FORTRAN Modern"
                
                    => Ok(FortranModern),
                    "FreeMarker"
                    => Ok(FreeMarker),
                    "F*"
                
                    => Ok(Fstar),
                    "Futhark"
                    => Ok(Futhark),
                    "GDB Script"
                
                    => Ok(GDB),
                    "GDScript"
                
                    => Ok(GdScript),
                    "Gherkin (Cucumber)"
                
                    => Ok(Gherkin),
                    "GLSL"
                
                    => Ok(Glsl),
                    "Go"
                    => Ok(Go),
                    "Go HTML"
                
                    => Ok(Gohtml),
                    "GraphQL"
                
                    => Ok(Graphql),
                    "Groovy"
                    => Ok(Groovy),
                    "Hamlet"
                    => Ok(Hamlet),
                    "Handlebars"
                    => Ok(Handlebars),
                    "Happy"
                    => Ok(Happy),
                    "Haskell"
                    => Ok(Haskell),
                    "Haxe"
                    => Ok(Haxe),
                    "HCL"
                
                    => Ok(Hcl),
                    "Headache"
                    => Ok(Headache),
                    "HEX"
                
                    => Ok(Hex),
                    "HLSL"
                
                    => Ok(Hlsl),
                    "HolyC"
                    => Ok(HolyC),
                    "HTML"
                
                    => Ok(Html),
                    "Idris"
                    => Ok(Idris),
                    "INI"
                
                    => Ok(Ini),
                    "Intel HEX"
                
                    => Ok(IntelHex),
                    "Isabelle"
                    => Ok(Isabelle),
                    "JAI"
                
                    => Ok(Jai),
                    "Java"
                    => Ok(Java),
                    "JavaScript"
                    => Ok(JavaScript),
                    "JSON"
                
                    => Ok(Json),
                    "JSX"
                
                    => Ok(Jsx),
                    "Julia"
                    => Ok(Julia),
                    "Julius"
                    => Ok(Julius),
                    "Kakoune script"
                
                    => Ok(KakouneScript),
                    "Kotlin"
                    => Ok(Kotlin),
                    "LLVM"
                    => Ok(LLVM),
                    "Lean"
                    => Ok(Lean),
                    "LESS"
                
                    => Ok(Less),
                    "LD Script"
                
                    => Ok(LinkerScript),
                    "Liquid"
                
                    => Ok(Liquid),
                    "Lisp"
                    => Ok(Lisp),
                    "Logtalk"
                    => Ok(Logtalk),
                    "Lua"
                    => Ok(Lua),
                    "Lucius"
                    => Ok(Lucius),
                    "Madlang"
                    => Ok(Madlang),
                    "Makefile"
                    => Ok(Makefile),
                    "Markdown"
                    => Ok(Markdown),
                    "Meson"
                    => Ok(Meson),
                    "Mint"
                    => Ok(Mint),
                    "Module-Definition"
                
                    => Ok(ModuleDef),
                    "MoonScript"
                    => Ok(MoonScript),
                    "MSBuild"
                
                    => Ok(MsBuild),
                    "Mustache"
                    => Ok(Mustache),
                    "Nim"
                    => Ok(Nim),
                    "Nix"
                    => Ok(Nix),
                    "Not Quite Perl"
                
                    => Ok(NotQuitePerl),
                    "OCaml"
                    => Ok(OCaml),
                    "Objective-C"
                
                    => Ok(ObjectiveC),
                    "Objective-C++"
                
                    => Ok(ObjectiveCpp),
                    "Odin"
                    => Ok(Odin),
                    "OpenType Feature File"
                
                    => Ok(OpenType),
                    "Org"
                    => Ok(Org),
                    "Oz"
                    => Ok(Oz),
                    "PSL Assertion"
                
                    => Ok(PSL),
                    "Pan"
                    => Ok(Pan),
                    "Pascal"
                    => Ok(Pascal),
                    "Perl"
                    => Ok(Perl),
                    "Rakudo"
                
                    => Ok(Perl6),
                    "Pest"
                    => Ok(Pest),
                    "PHP"
                
                    => Ok(Php),
                    "Polly"
                    => Ok(Polly),
                    "Pony"
                    => Ok(Pony),
                    "PostCSS"
                
                    => Ok(PostCss),
                    "PowerShell"
                    => Ok(PowerShell),
                    "Processing"
                    => Ok(Processing),
                    "Prolog"
                    => Ok(Prolog),
                    "Protocol Buffers"
                
                    => Ok(Protobuf),
                    "PureScript"
                    => Ok(PureScript),
                    "Python"
                    => Ok(Python),
                    "QCL"
                
                    => Ok(Qcl),
                    "QML"
                
                    => Ok(Qml),
                    "R"
                    => Ok(R),
                    "Rusty Object Notation"
                
                    => Ok(RON),
                    "RPM Specfile"
                
                    => Ok(RPMSpecfile),
                    "Racket"
                    => Ok(Racket),
                    "Rakefile"
                    => Ok(Rakefile),
                    "Razor"
                    => Ok(Razor),
                    "ReStructuredText"
                    => Ok(ReStructuredText),
                    "Ren'Py"
                
                    => Ok(Renpy),
                    "Ruby"
                    => Ok(Ruby),
                    "Ruby HTML"
                
                    => Ok(RubyHtml),
                    "Rust"
                    => Ok(Rust),
                    "SRecode Template"
                
                    => Ok(SRecode),
                    "Sass"
                    => Ok(Sass),
                    "Scala"
                    => Ok(Scala),
                    "Scheme"
                    => Ok(Scheme),
                    "Scons"
                    => Ok(Scons),
                    "Shell"
                
                    => Ok(Sh),
                    "Standard ML (SML)"
                
                    => Ok(Sml),
                    "Solidity"
                
                    => Ok(Solidity),
                    "Specman e"
                
                    => Ok(SpecmanE),
                    "Spice Netlist"
                
                    => Ok(Spice),
                    "SQL"
                
                    => Ok(Sql),
                    "Stratego/XT"
                
                    => Ok(Stratego),
                    "Svelte"
                    => Ok(Svelte),
                    "SVG"
                
                    => Ok(Svg),
                    "Swift"
                    => Ok(Swift),
                    "SWIG"
                
                    => Ok(Swig),
                    "SystemVerilog"
                    => Ok(SystemVerilog),
                    "TCL"
                
                    => Ok(Tcl),
                    "TeX"
                
                    => Ok(Tex),
                    "Plain Text"
                
                    => Ok(Text),
                    "Thrift"
                    => Ok(Thrift),
                    "TOML"
                
                    => Ok(Toml),
                    "TSX"
                
                    => Ok(Tsx),
                    "Twig"
                
                    => Ok(Twig),
                    "TypeScript"
                    => Ok(TypeScript),
                    "Unreal Markdown"
                
                    => Ok(UnrealDeveloperMarkdown),
                    "Unreal Plugin"
                
                    => Ok(UnrealPlugin),
                    "Unreal Project"
                
                    => Ok(UnrealProject),
                    "Unreal Script"
                
                    => Ok(UnrealScript),
                    "Unreal Shader"
                
                    => Ok(UnrealShader),
                    "Unreal Shader Header"
                
                    => Ok(UnrealShaderHeader),
                    "Ur/Web"
                
                    => Ok(UrWeb),
                    "Ur/Web Project"
                
                    => Ok(UrWebProject),
                    "VB6"
                
                    => Ok(VB6),
                    "VBScript"
                
                    => Ok(VBScript),
                    "Vala"
                    => Ok(Vala),
                    "Apache Velocity"
                
                    => Ok(Velocity),
                    "Verilog"
                    => Ok(Verilog),
                    "Verilog Args File"
                
                    => Ok(VerilogArgsFile),
                    "VHDL"
                
                    => Ok(Vhdl),
                    "Vim Script"
                
                    => Ok(VimScript),
                    "Visual Basic"
                
                    => Ok(VisualBasic),
                    "Visual Studio Project"
                
                    => Ok(VisualStudioProject),
                    "Visual Studio Solution"
                
                    => Ok(VisualStudioSolution),
                    "Vue"
                
                    => Ok(Vue),
                    "WebAssembly"
                    => Ok(WebAssembly),
                    "Wolfram"
                    => Ok(Wolfram),
                    "XSL"
                
                    => Ok(XSL),
                    "XAML"
                
                    => Ok(Xaml),
                    "Xcode Config"
                
                    => Ok(XcodeConfig),
                    "XML"
                
                    => Ok(Xml),
                    "Xtend"
                    => Ok(Xtend),
                    "YAML"
                
                    => Ok(Yaml),
                    "Zig"
                    => Ok(Zig),
                    "Zsh"
                    => Ok(Zsh),
            _ => Err("Language not found, please use `-l` to see all available\
                     languages."),
        }
    }
}

impl fmt::Display for LanguageType {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "{}", self.name())
    }
}


impl<'a> From<LanguageType> for Cow<'a, LanguageType> {
    fn from(from: LanguageType) -> Self {
        Cow::Owned(from)
    }
}

impl<'a> From<&'a LanguageType> for Cow<'a, LanguageType> {
    fn from(from: &'a LanguageType) -> Self {
        Cow::Borrowed(from)
    }
}


/// This is for getting the file type from the first line of a file
pub fn get_filetype_from_shebang(file: &Path) -> Option<&'static str>
{
    let file = match File::open(file) {
        Ok(file) => file,
        _ => return None,
    };

    let mut buf = BufReader::new(file);
    let mut line = String::new();
    let _ = buf.read_line(&mut line);

    let mut words = line.split_whitespace();
    match words.next() {
        
        | Some("#!/bin/bash")
            => Some("Bash"),
        | Some("#!/bin/csh")
            => Some("CShell"),
        | Some("#!/usr/bin/crystal")
            => Some("Crystal"),
        | Some("#!/bin/fish")
            => Some("Fish"),
        | Some("#!/usr/bin/perl")
            => Some("Perl"),
        | Some("#!/bin/sh")
            => Some("Sh"),
        | Some("#!/bin/zsh")
            => Some("Zsh"),
        Some("#!/usr/bin/env") => {
            if let Some(word) = words.next() {
                match word {
                                "bash"
                                => Some("Bash"),
                                "csh"
                                => Some("CShell"),
                                "crystal"
                                => Some("Crystal"),
                                "elvish"
                                => Some("Elvish"),
                                "fish"
                                => Some("Fish"),
                                "python"
                                    |
                                "python2"
                                    |
                                "python3"
                                => Some("Python"),
                                "ruby"
                                => Some("Ruby"),
                                "sh"
                                => Some("Sh"),
                    env => {
                        warn!("Unknown environment: {:?}", env);
                        None
                    }
                }
            } else {
                None
            }
        }
        _ => None,
    }
}

